<?php

$action = (isset($_REQUEST['action']))? $_REQUEST['action'] : '';
$refresh = isset($_GET['refresh']);
$username = (isset($_POST['username']))? $_POST['username'] : '';
$password = (isset($_POST['password']))? $_POST['password'] : '';

$model = new AuthModel;

switch ($action)
{
	case "login":
		if ($username !== '' && $password !== '' && $model->login($username, $password))
		{
			Audit::track('login');
			header("Location: /logserver/");
			exit;
		}
		else
			Audit::track('login', "Username: '$username'");
		break;

	case "logout":
		Audit::track('logout');
		$model->logout();
		header("Location: /logserver/");
		exit;

	case "get_info":

		$data = array(
			"username" => Auth::$username,
			"date" => date("Y-m-d H:i"),
			"version" => "unknown",
			"count" => $model->getMessagesNums()
		);

		if (file_exists("/opt/logserver/op5-logserver-version")) {
			$version = "unknown";
			$f = fopen("/opt/logserver/op5-logserver-version", "r");
			if ($f) {
				$version = fgets($f);
				fclose($f);
			}
			$data["version"] = $version;
		}

		echo json_encode($data);

		exit;

	case "get_username":
		echo Auth::$username;
		if ($refresh && isset($_SESSION['username']) && isset($_SESSION['password']))
		{
			$_SESSION['username'] = $_SESSION['username'];
			$_SESSION['password'] = $_SESSION['password'];
		}
		elseif (!Auth::$is_admin['user'])
			echo '<span></span>'; // set flag to logout user from admin page
		exit;

	case "get_date":
		echo date("Y-m-d H:i");
		exit;

	case "get_version":
		$version = "unknown";
		if (file_exists("/opt/logserver/op5-logserver-version"))
		{
			$f = fopen("/opt/logserver/op5-logserver-version", "r");
			if($f)
			{
				$version = fgets($f);
				fclose($f);
			}
		}
		echo "$version";
		exit;

	case "get_count":
		$nums = $model->getMessagesNums();
		echo "$nums";
		exit;

	default:
		// do not show auth page to authorized users
		if (Auth::$username !== false)
		{
			header("Location: /logserver/");
			exit;
		}
}
