<?php

function array_compact($array)
{
	$result = array();

	foreach ($array as $key)
		$result[] = $key['name'];

	return $result;
}

class FiltersModel
{
	function exists($filtername)
	{
		$existing = Database::query("SELECT name FROM filters WHERE name='$filtername'");

		return count($existing)? true : false;
	}

	function is_accessible($filtername, $username)
	{
		$accessible = Database::query("SELECT name FROM show_global_filters('$username')"
			. " WHERE name = '$filtername' AND permissions = B'1' GROUP BY name");

		return count($accessible)? true : false;
	}

	function is_global($filtername)
	{
		$global = Database::query("SELECT name FROM filters WHERE name='$filtername' AND owner_id IS NULL");

		return count($global)? true : false;
	}

	function is_own($filtername, $username)
	{
		$own = Database::query("SELECT name FROM show_own_filters('$username') WHERE name='$filtername'");

		return count($own)? true : false;
	}

	function add_global_filter($filtername, $query, $parentfiltername)
	{
		$result = Database::query("SELECT insert_global_filter('$filtername', '$query', '$parentfiltername')");
		if ($result[0]['insert_global_filter'] == 't')
		{
			Database::query("INSERT INTO summary_reports (filter_id) SELECT id FROM filters WHERE name = '$filtername'");
			return true;
		}
		else
			return false;
	}

	function add_own_filter($filtername, $query, $username, $parentfiltername)
	{
		Database::query("SELECT insert_own_filter('$filtername', '$query', '$username', '$parentfiltername')");
	}


	function check_parents($oldfiltername, $newfiltername)
	{
		$currentfilter = $oldfiltername;
		while (true)
		{
			if ($currentfilter == $newfiltername)
				return false;

			$result = Database::query("SELECT name FROM get_parent('$currentfilter')");
			if (!count($result))
				return true;

			$currentfilter = $result[0]['name'];
		}

		return true;
	}

	function has_children($filtername)
	{
		$result = Database::query('SELECT name FROM filters WHERE parent_id ='
			. " (SELECT id FROM filters WHERE name = '$filtername')");

		return count($result)? true : false;
	}

	function update_filter($filtername, $query, $parentfiltername)
	{
		Database::query("UPDATE filters SET name='$filtername', query='$query',"
			. " parent_id=(SELECT id FROM filters WHERE name='$parentfiltername') WHERE name='$filtername'");
	}

	function rename_filter($oldfiltername, $newfiltername)
	{
		$result = Database::query("UPDATE filters SET name='$newfiltername' WHERE name='$oldfiltername'");

		return count($result)? true : false;
	}

	function remove_filter($filtername)
	{
		Database::query("DELETE FROM filters WHERE name='$filtername'");
	}

	function add_filter_user($filtername, $username)
	{
		Database::query("SELECT insert_filteruser('$filtername', '$username', B'1')");
	}

	function get_query($filtername)
	{
		$result = Database::query("SELECT query FROM filters WHERE name='$filtername'");

		return $result[0]['query'];
	}

	function get_parent_filter($filtername)
	{
		$result = Database::query("SELECT name FROM get_parent('$filtername')");

		return (count($result))? $result[0]['name'] : null;
	}

	function get_global_filters($username)
	{
		$result = Database::query("SELECT name FROM show_user_groups('$username') WHERE name = 'Filter administrators'");
		if (count($result))
			return array_compact(Database::query("SELECT name FROM filters WHERE owner_id IS NULL ORDER BY name"));
		else
			return array_compact(Database::query("SELECT name FROM show_global_filters('$username') WHERE permissions = B'1' GROUP BY name, query ORDER BY name"));
	}

	function get_own_filters($username)
	{
		return array_compact(Database::query("SELECT name FROM show_own_filters('$username') ORDER BY name"));
	}

	function make_global($filtername, $username)
	{
		Database::query("UPDATE filters SET owner_id=NULL WHERE name='$filtername'");
		$result = Database::query("SELECT id  FROM summary_reports WHERE filter_id = (SELECT id FROM filters WHERE name = '$filtername')");
		if (count($result) == 0)
			Database::query("INSERT INTO summary_reports (filter_id) SELECT id FROM filters WHERE name = '$filtername'");

		// do the same for all private parents
		$currentfilter = $filtername;
		while (true)
		{
			$result = Database::query("SELECT name FROM get_parent('$currentfilter')");
			if (!count($result))
				break;

			$currentfilter = $result[0]['name'];
			$result = Database::query("SELECT name FROM show_own_filters('$username') WHERE name='$currentfilter'");
			if (!count($result))
				continue;

			Database::query("UPDATE filters SET owner_id=NULL WHERE name='$currentfilter'");
			$result = Database::query("SELECT id  FROM summary_reports WHERE filter_id = (SELECT id FROM filters WHERE name = '$currentfilter')");
			if (count($result) == 0)
				Database::query("INSERT INTO summary_reports (filter_id) SELECT id FROM filters WHERE name = '$currentfilter'");
		}
	}

	private function make_children_own(&$filters, &$username)
	{
		foreach ($filters as $filter)
		{
			if (!$filter['owner_id'])
			{
				Database::query("SELECT make_filter_own('{$filter['name']}', '$username')");
				Database::query("DELETE FROM summary_reports WHERE filter_id = {$filter['id']}");
			}

			$children = Database::query("SELECT * FROM filters WHERE parent_id = {$filter['id']}");
			if (count($children))
				$this->make_children_own($children, $username);
		}
	}

	function make_own($filtername, $username)
	{
		Database::query("SELECT make_filter_own('$filtername', '$username')");
		Database::query("DELETE FROM summary_reports WHERE filter_id = (SELECT id FROM filters WHERE name = '$filtername')");

		// do the same for all global children
		$filters = Database::query("SELECT * FROM filters WHERE name = '$filtername'");
		if (count($filters))
			$this->make_children_own($filters, $username);
	}

	function get_group_filters($groupname)
	{
		if ($groupname == 'Filter administrators')
			return array_compact(Database::query("SELECT name FROM filters WHERE owner_id IS NULL ORDER BY name"));
		else
			return array_compact(Database::query("SELECT name FROM show_group_filters('$groupname')"));
	}

	function get_user_filters($username)
	{
		$result = Database::query("SELECT name FROM show_user_groups('$username') WHERE name = 'Filter administrators'");
		if (count($result))
			return array_compact(Database::query("SELECT name FROM filters WHERE owner_id IS NULL ORDER BY name"));
		else
			return array_compact(Database::query("SELECT name FROM filters, "
				. " (SELECT filter_id FROM filterusers WHERE user_id = (SELECT id FROM users WHERE name = '$username')"
				. " AND permission = B'1') AS ids WHERE filters.id = ids.filter_id"));
	}

	function get_default_filter($username)
	{
		$result = Database::query("SELECT name FROM filters WHERE id = (SELECT default_filter_id FROM users WHERE name = '$username')");

		return (count($result))? $result[0]['name'] : null;
	}

	function get_exportable_filters()
	{
		$result = Database::query("SELECT f.name, p.name AS parent, '' AS owner FROM filters f"
			. " LEFT JOIN filters p ON f.parent_id = p.id"
			. " WHERE f.name != 'All' AND f.owner_id IS NULL AND p.name != ''");

		$result = array_merge($result, Database::query("SELECT f.name, p.name AS parent, u.name AS owner FROM filters f"
			. " LEFT JOIN filters p ON f.parent_id = p.id LEFT JOIN users u ON f.owner_id = u.id"
			. " WHERE f.owner_id IS NOT NULL"));

		return $result;
	}
}
