<?php

if (!Auth::$is_admin['filter'])
	exit;

$filter = (isset($_POST['filter']))? $_POST['filter'] : 'All';
$type = (isset($_POST['type']))? $_POST['type'] : 'allowed';
$view = (isset($_POST['view']))? $_POST['view'] : 'groups';
$action = (isset($_POST['action']))? $_POST['action'] : '';
$users = (isset($_POST['users']))? $_POST['users'] : array();
$groups = (isset($_POST['groups']))? $_POST['groups'] : array();

$model = new FilterUsersModel;

if ($action == 'add' && count($users))
{
	Audit::track('allow filter for user(s)', "Filter: '$filter'");
	foreach ($users as $user)
		$model->add_user($filter, $user);
}
elseif ($action == 'remove' && count($users))
{
	Audit::track('disallow filter for user(s)', "Filter: '$filter'");
	foreach ($users as $user)
		$model->remove_user($filter, $user);
}
elseif ($action == 'add' && count($groups))
{
	Audit::track('allow filter for group(s)', "Filter: '$filter'");
	foreach ($groups as $group)
		$model->add_group($filter, $group);
}
if ($action == 'remove' && count($groups))
{
	Audit::track('disallow filter for group(s)', "Filter: '$filter'");
	foreach ($groups as $group)
		$model->remove_group($filter, $group);
}

if ($type == 'allowed')
{
	$users = $model->get_allowed_users($filter, false);
	$groups = $model->get_allowed_groups($filter);
}
elseif ($type == 'disallowed')
{
	$users = $model->get_disallowed_users($filter, false);
	$groups = $model->get_disallowed_groups($filter);
}
