<?php

if (!Auth::$is_admin['user'])
{
	header('Location: /logserver/error.html');
	exit;
}

$action = (isset($_REQUEST['action']))? $_REQUEST['action'] : '';
$orig_groupname = (isset($_REQUEST['orig_groupname']))? trim($_REQUEST['orig_groupname']) : '';
$groupname = (isset($_REQUEST['groupname']))? trim($_REQUEST['groupname']) : $orig_groupname;
$description = (isset($_POST['description']))? trim($_POST['description']) : '';
$have_users_in_group = (isset($_POST['users'])) ? $_POST['users'] : array();

$username = (isset($_REQUEST['username']))? trim($_REQUEST['username']) : '';

$simple = (isset($_GET['simple']))? $_GET['simple'] : '';
$type = (isset($_GET['type']))? $_GET['type'] : '';

$model = new GroupsModel;

if ($action == "add_group")
{
	Audit::track('add group', "Name: '$groupname'");
	if ($groupname != "")
		$model->add_group($groupname, $description);
	foreach ($have_users_in_group as $user)
		$model->insert_user_group($user, $groupname);
}
elseif ($action == "get_group_list") {
	print json_encode($model->list_groups(true));
	exit;
}
elseif ($action == "delete")
{
	Audit::track('delete group', "Name: '$groupname'");
	if ($groupname != "")
    {
		$model->delete_group($groupname);
		$deleted = true;
	}
}
elseif ($action == "save")
{
	Audit::track('edit group', "Name: '$orig_groupname'");
	if ($groupname !== $orig_groupname)
		$model->change_name($orig_groupname, $groupname);

	$model->change_description($description, $groupname);

	$users_in_group = $model->users_in_group($groupname);
	$was_users_in_group = array();
	foreach ($users_in_group as $uig)
		$was_users_in_group[] = $uig['name'];

	$need_insert = array_diff ($have_users_in_group, $was_users_in_group);

	if (count($have_users_in_group) == 0)
		$need_delete = $was_users_in_group;
	else
		$need_delete = array_diff ($was_users_in_group, $have_users_in_group);

	$need_delete_str = "'".implode("','",$need_delete)."'";

	foreach ($need_insert as $user)
		$model->insert_user_group($user, $groupname);

	if (count($need_delete) > 0)
		$model->delete_user_group($need_delete_str, $groupname);
}

if ($simple != "" && $type != "" && $username != "")
{
	if ($type == 'in')
		$groups = $model->groups_in_user($username);
	elseif ($type == 'out')
		$groups = $model->groups_out_user($username);
	else
		$groups = $model->list_groups(false);
}
else
{
	Audit::track('view groups');
	$groups = $model->list_groups(false);
}
