<?php

$year = (isset($_GET['year']))? $_GET['year'] : '';
$month = (isset($_GET['month']))? $_GET['month'] : '';
$day = (isset($_GET['day']))? $_GET['day'] : '';
$hour = (isset($_GET['hour']))? $_GET['hour'] : '';
$check = (isset($_POST['check']))? explode(',', $_POST['check']) : array();

if (count($check) && !Auth::$is_admin['import'])
{
	header('Location: /logserver/error.html');
	exit;
}

$model = new ImportModel;

if (isset($_GET['sanity']) && ($year !== '') && ($month !== '') && ($day !== '') && ($hour !== ''))
{
	$model->check_size($year, $month, $day, $hour);
} elseif (($year !== '') && ($month !== '') && ($day !== '') && ($hour !== ''))
{
	Audit::track('import logs', "Table(s): {$year}_{$month}_{$day}_{$hour}");
	if ($model->is_in_db($year, $month, $day, $hour))
		echo "{$year}_{$month}_{$day}_{$hour} is already in the database.";
	elseif ($model->is_importing($year, $month, $day, $hour))
		echo "Importing of {$year}_{$month}_{$day}_{$hour} is already in progress.";
	else
	{
		echo "Importing {$year}_{$month}_{$day}_{$hour}...";
		$model->import_hour($year, $month, $day, $hour);
	}
}
elseif (isset($_GET['sanity']) && ($year !== '') && ($month !== '') && ($day !== ''))
{
	$model->check_size($year, $month, $day);
}
elseif (($year !== '') && ($month !== '') && ($day !== ''))
{
	Audit::track('import logs', "Table(s): {$year}_{$month}_{$day}_xx");
	echo "Importing {$year}_{$month}_{$day}...";
	$model->import_day($year, $month, $day);
}
elseif (isset($_GET['sanity']) && ($year !== '') && ($month !== ''))
{
	$model->check_size($year, $month);
} 
elseif (($year !== '') && ($month !== ''))
{
	Audit::track('import logs', "Table(s): {$year}_{$month}_xx_xx");
	echo "Importing {$year}_{$month}...";
	$model->import_month($year, $month);
}

if (count($check))
	$tables = $model->check_tables($check);
else
	$tables = $model->list_tables();
