<?php

class LSQ2HTML
{
	protected static $columns = array(
		'ip'        => 'source_ip',
		'src_ip'    => 'source_ip',
		'source_ip' => 'source_ip',
		'sourceip'  => 'source_ip',
		'rtime'     => 'rtime',
		'recv_time' => 'rtime',
		'fac'       => 'facility',
		'facility'  => 'facility',
		'sev'       => 'severity',
		'severity'  => 'severity',
		'mtime'     => 'mtime',
		'msg_time'  => 'mtime',
		'host'      => 'host',
		'ident'     => 'ident',
		'pid'       => 'pid',
		'event'     => 'event_id',
		'event_id'  => 'event_id',
		'eventid'   => 'event_id',
		'msg'       => 'msg',
		'message'   => 'msg',
		''          => 'fts'
	);


	protected static $severities = array(
		'emergency' => 'emergency',
		'emerg'     => 'emergency',
		'alert'     => 'alert',
		'critical'  => 'critical',
		'crit'      => 'critical',
		'error'     => 'error',
		'err'       => 'error',
		'warning'   => 'warning',
		'warn'      => 'warning',
		'notice'    => 'notice',
		'info'      => 'info',
		'debug'     => 'debug'
	);

	protected static function unalias_column($column)
	{
		if (!array_key_exists($column, self::$columns))
			return $column;
		else
			return self::$columns[$column];
	}


	protected static function unalias_severity($severity)
	{
		if (!array_key_exists($severity, self::$severities))
			return $severity;
		else
			return self::$severities[$severity];
	}


	public static function translate($tree)
	{
		foreach ($tree as $node)
		{
			$node['column'] = self::unalias_column($node['column']);
			if ($node['column'] == 'severity')
				foreach ($node['args'] as $index => $arg)
					$node['args'][$index] = self::unalias_severity($arg);

			echo '<div>';
			echo '<div>' . $node['condition'] . '</div>';
			echo '<div>' . htmlspecialchars($node['column']) . '</div>';
			echo '<div>' . $node['operator'] . '</div>';
			echo '<div>';
			foreach ($node['args'] as $arg)
				echo '<div>' . htmlspecialchars($arg) . '</div>';
			echo '</div>';
			echo '</div>';
		}
	}
}
