<?php

include ('comps/inquire/lsqtypes.php');
include ('comps/inquire/lsqparser.php');
include ('comps/inquire/lsq2sql.php');

class LogsModel
{
	public $table_prev = '';
	public $table_next = '';
	public $table_next2 = '';
	public $table_new = '';

	private function get_prev_table($table)
	{
		$result = Database::query("SELECT substring(name from 10 for 14) AS prev FROM tables_registry WHERE"
			. " get_location(location) = 'database' AND name < 'messages_$table'"
			. " ORDER BY name DESC LIMIT 1");

		return (count($result))? $result[0]['prev'] : '';
	}

	private function get_next_table($table)
	{
		$result = Database::query("SELECT substring(name from 10 for 14) AS next FROM tables_registry WHERE"
			. " get_location(location) = 'database' AND name > 'messages_$table'"
			. " ORDER BY name LIMIT 1");

		return (count($result))? $result[0]['next'] : '';
	}

	private function get_next2_table($table)
	{
		$result = Database::query("SELECT substring(name from 10 for 14) AS next2 FROM tables_registry WHERE"
			. " get_location(location) = 'database' AND name > 'messages_$table'"
			. " ORDER BY name OFFSET 1 LIMIT 1");

		return (count($result))? $result[0]['next2'] : '';
	}

	private function get_last_table()
	{
		$result = Database::query("SELECT substring(name from 10 for 14) AS last FROM tables_registry WHERE"
			. " get_location(location) = 'database' ORDER BY name DESC LIMIT 1");

		return (count($result))? $result[0]['last'] : '';
	}

	public function tables_in_range($start_time, $end_time)
	{
		$start_table = str_replace(array('-', ' ', ':'), '_', substr($start_time, 0, 13));
		$end_table = str_replace(array('-', ' ', ':'), '_', substr($end_time, 0, 13));

		return Database::query("SELECT substring(name from 10 for 14) AS name"
			. " FROM tables_registry WHERE get_location(location) = 'database'"
			. " AND name >= 'messages_$start_table' AND name <= 'messages_$end_table'"
			. " ORDER BY name");
	}

	public function get_logs($query, $fields, $table, $offset, $limit, $direction, $start_time, $end_time)
	{
		$query = trim($query);
		/* DEBUG
		try
		{
			echo '<pre>';
			print_r(LSQParser::parseQuery($query));
			echo '</pre>';
			echo 'query: ' . (LSQ2SQL::translate(LSQParser::parseQuery($query)));
			echo '<hr />';
		}
		catch(Exception $e)
		{
			return array();
		}
		/**/
		if ($query !== '')
		{
			try
			{
				$query = trim(LSQ2SQL::translate(LSQParser::parseQuery($query)));
			}
			catch(Exception $e)
			{
				return array();
			}
		}

		if ($table == '')
		{
			$table = $this->get_last_table();
			if ($table == '')
				return array();
		}

		$this->table_new = $table;

		/* required for check_ls_log, but not really needed for reportsend */
		if ($start_time != '' && $end_time != '')
			$query .= (($query !== '')? ' AND ' : '') . "rtime >= '$start_time'"
				. " AND rtime <= '$end_time'";

		/* DEBUG
		echo "SELECT $fields FROM messages_$table"
			. (($query !== '')? " WHERE $query" : '')
			. " ORDER BY id" . (($direction == 'backwards')? ' DESC' : '')
			. " LIMIT $limit OFFSET $offset");
		*/
		$result = Database::query("SELECT $fields FROM messages_$table"
			. (($query !== '')? " WHERE $query" : '')
			. " ORDER BY id" . (($direction == 'backwards')? ' DESC' : '')
			. " LIMIT $limit OFFSET $offset");

		if ($direction == 'backwards')
			$result = array_reverse($result);

		if (count($result) == 0)
			$offset = 0;

		/* TODO: fix for multi-hour-spanned search */
		$this->table_prev = $this->get_prev_table($table);
		$this->table_next = $this->get_next_table($table);
		$this->table_next2 = $this->get_next_table($table);

		return $result;
	}

	public function get_offset($query, $table, $direction, $offset_time)
	{
		$query = trim($query);
		if ($query !== '')
		{
			try
			{
				$query = trim(LSQ2SQL::translate(LSQParser::parseQuery($query)));
			}
			catch(Exception $e)
			{
				return 0;
			}
		}

		$result = Database::query("SELECT COUNT(*) FROM messages_$table"
			. " WHERE rtime " . ($direction == 'backwards' ? '<' : '>') . " '$offset_time'"
			. (($query !== '')? " AND $query" : ''));

		return $result[0]['count'];
	}
}
