<?php

if ($_SERVER['REMOTE_ADDR'] != '127.0.0.1' && !Auth::$username)
{
	header('Location: /logserver/error.html');
	exit;
}

function getParam($from, $name, $default = NULL) {
	if (!is_array($from) && !($from instanceof ArrayAccess)) {
		return $default;
	}

	if(!isset($from[$name])) {
		return $default;
	}

	return $from[$name];
}

$action = getParam($_REQUEST, "action");
$model = new LdapmapModel();

switch($action) {
	case "getItems":
		$data = $model->get_group_mapping();
		$result = array();
		foreach($data as $key => $item) {
			$result[$key] = array($item["name"], implode(", ", $item["groups"]));
		}
		print json_encode($result);
		break;
	case "addItem":
		$name = getParam($_POST, "name");
		$ldapmap = getParam($_POST, "ldapmap", array());
		if ($model->is_group_exist($name)) {
			die("Group already exists!");
		}
		$model->add_group($name, $ldapmap);
		header("Location: /logserver/view/settings");
		exit;
		break;
	case "editItem":
		$old_id = getParam($_POST, "old_id");
		$name = getParam($_POST, "name");
		$ldapmap = getParam($_POST, "ldapmap", array());
		$model->update_group($old_id, $name, $ldapmap);
		header("Location: /logserver/view/settings");
		exit;
		break;
	case "deleteItem":
		$id = intval(getParam($_GET, "id"));
		if (!$id) {
			die("You should select group id!");
		}
		$model->delete_group($id);
		print json_encode(array("result" => true));
		break;
	case "getInfo":
		$id = intval(getParam($_REQUEST, "id"));
		if (!$id) {
			die("you should select id");
		}
		print json_encode($model->get_group_info($id));
		break;
	case "toggleLdap":
		require_once("comps/settings/model.php");
		$setting_model = new SettingsModel();
		$setting_model->toggle_ldap();
		header("Location: /logserver/view/settings");
		exit;
		break;
	default:
		print("No action handler!");
		exit;
}