<?php

class LdapmapModel {
	function is_group_exist($groupname) {
		$group_exist = Database::query("SELECT COUNT(\"id\") as \"isset\" FROM ldap_groups WHERE name = ('$groupname');");
		return intval($group_exist[0]["isset"]) !== 0;
	}

	function add_group($groupname, array $logserver_groups) {
		$result = Database::query("INSERT INTO ldap_groups (name) VALUES ('".pg_escape_string($groupname)."');");
		if (!$result) {
			throw new Exception("Can't add user to database");
		}
		if (empty($logserver_groups)) {
			return;
		}
		$result = Database::query("SELECT currval('ldap_groups_id_seq');");
		$new_group_id = intval($result[0]["currval"]);
		$sql = "INSERT INTO ldap_groups_mapping (ldap_group_id, group_id) VALUES ";
		$sql_parts = array();
		foreach($logserver_groups as $group_id) {
			$sql_parts[] = "('$new_group_id', '$group_id')";
		}
		$sql .= implode(", ", $sql_parts) . ";";
		return Database::query($sql);
	}

	function get_group_mapping() {
		$result = Database::query("SELECT lg.id, lg.name, lgm.group_id, g.name as group_name, g.id as group_id FROM ldap_groups as lg LEFT JOIN ldap_groups_mapping as lgm ON lg.id = lgm.ldap_group_id LEFT JOIN groups as g ON lgm.group_id = g.id;");
		$retval = array();
		foreach($result as $val) {
			if ($val["group_id"] == 1) {
				continue;
			}
			if (!isset($retval[$val["id"]])) {
				$retval[$val["id"]] = array(
					"name" => $val["name"],
					"groups" => array()
				);
			}
			$retval[$val["id"]]["groups"][$val["group_id"]] = $val["group_name"];
		}
		return $retval;
	}

	function delete_group($id) {
		$id = intval($id);
		Database::query("DELETE FROM ldap_groups WHERE id = ('$id');");
		Database::query("DELETE FROM ldap_groups_mapping WHERE ldap_group_id = ('$id');");
	}

	function get_group_info($id) {
		$id = intval($id);
		return Database::query("SELECT g.name, g.description, lgm.group_id as id FROM ldap_groups_mapping as lgm LEFT JOIN groups as g ON lgm.group_id = g.id WHERE lgm.ldap_group_id = ('$id') AND g.id <> 1;");
	}

	function update_group($id, $groupname, array $logserver_groups) {
		$result = Database::query("UPDATE ldap_groups SET name = ('$groupname') WHERE id = ('$id');");
		Database::query("DELETE FROM ldap_groups_mapping WHERE ldap_group_id = ('$id');");
		if (empty($logserver_groups)) {
			return;
		}
		$sql = "INSERT INTO ldap_groups_mapping (ldap_group_id, group_id) VALUES ";
		$sql_parts = array();
		foreach($logserver_groups as $group_id) {
			$sql_parts[] = "('$id', '$group_id')";
		}
		$sql .= implode(", ", $sql_parts) . ";";
		return Database::query($sql);
	}
}