<?php

if (!Auth::$is_admin['filter'] && !Auth::$is_admin['summary'])
{
	header('Location: /logserver/error.html');
	exit;
}

$filter = (isset($_REQUEST['filter']))? $_REQUEST['filter'] : '';
$action = (isset($_REQUEST['action']))? $_REQUEST['action'] : '';
$type = (isset($_REQUEST['type']))? $_REQUEST['type'] : '';
$username = (isset($_REQUEST['username']))? $_REQUEST['username'] : '';
$time = (isset($_REQUEST['time']))? $_REQUEST['time'] : false;

$model = new SummaryReportsModel;

if ($action == "create")
{
	Audit::track('create summary report', "Filter: '$filter'");
	$model->add_summary_reports($filter);
}
elseif ($action == "delete")
{
	Audit::track('delete summary report', "Filter: '$filter'");
	$model->delete_summary_reports($filter);
}
elseif ($type != 'graph')
	Audit::track('view summary reports');

switch($type)
{
	case "addglobal":
		$global_filters = $model->get_unique_global_filters();
		break;

	case "addprivate":
		$private_filters = $model->get_unique_private_filters($username);
		break;

	case "user":
		$users = $model->get_all_users();
		break;

	case "host":
		$hosts = $model->get_top_hosts($filter);
		break;

	case "graph":
		Audit::track('view summary report', "Filter: '$filter'");
		$filter_id = $model->get_filter_id($filter);
		break;

	case "global":
		if (Auth::$is_admin['filter'])
			$all_global_reports = $model->get_all_global_summary_reports();
		else
			$all_global_reports = $model->get_global_summary_reports(Auth::$username);
		break;

	case "private":
		if (Auth::$is_admin['filter'])
			$all_private_reports = $model->get_all_summary_private_filters();
		else
			$all_private_reports = $model->get_private_summary_reports(Auth::$username);
		break;
}
