<?php

class TimelineModel extends Database
{
	public function get_months()
	{
		$months = array();

		$result = Database::query("SELECT * FROM (SELECT SUBSTRING(name FROM 10 FOR 7) AS month,"
			. " get_location(location) AS location FROM tables_registry"
			. " WHERE name LIKE 'messages_%' AND get_location(location) != 'empty'"
			. " ORDER BY month) AS tmptable GROUP BY month, location ORDER BY month");

		foreach ($result as $row)
		{
			if (!isset($months[$row['month']]))
				$months[$row['month']] = ($row['location'] == 'database')? 'in_db' : 'in_archive';
			elseif ($months[$row['month']] == 'in_db')
				continue;
			elseif ($row['location'] == 'database')
				$months[$row['month']] = 'in_db';
			else
				$months[$row['month']] = 'in_archive';
		}

		return $months;
	}

	public function get_days($month)
	{
		$days = array();

		$result = Database::query("SELECT * FROM (SELECT SUBSTRING(name FROM 18 FOR 2) AS day,"
			. " get_location(location) AS location FROM tables_registry"
			. " WHERE name LIKE 'messages_{$month}_%' AND get_location(location) != 'empty'"
			. " ORDER BY day) AS tmptable GROUP BY day, location ORDER BY day");

		foreach ($result as $row)
		{
			if (!isset($days[$row['day']]))
				$days[$row['day']] = ($row['location'] == 'database')? 'in_db' : 'in_archive';
			elseif ($days[$row['day']] == 'in_db')
				continue;
			elseif ($row['location'] == 'database')
				$days[$row['day']] = 'in_db';
			else
				$days[$row['day']] = 'in_archive';
		}

		return $days;
	}

	public function get_hours($month, $day)
	{
		$hours = array();

		$result = Database::query("SELECT SUBSTRING(name FROM 21 FOR 2) AS hour,"
			. " get_location(location) AS location, import_status FROM tables_registry"
			. " WHERE name LIKE 'messages_{$month}_{$day}_%' AND get_location(location) != 'empty' ORDER BY hour");

		foreach ($result as $row)
			if ($row['location'] == 'database')
				$hours[$row['hour']] = array('location' => 'in_db', 'status' => 'normal');
			else // 'local' or 'remote'
				if ($row['import_status'] == 'planned' || $row['import_status'] == 'started')
					$hours[$row['hour']] = array('location' => 'in_archive', 'status' => 'importing');
				elseif ($row['import_status'] == 'failed')
					$hours[$row['hour']] = array('location' => 'in_archive', 'status' => 'failed');
				else
					$hours[$row['hour']] = array('location' => 'in_archive', 'status' => 'normal');

		return $hours;
	}
}
