<?php

if (!Auth::$is_admin['user'])
{
	header('Location: /logserver/error.html');
	exit;
}

$action = (isset($_REQUEST['action']))? $_REQUEST['action'] : '';
$orig_username = (isset($_POST['orig_username']))? $_POST['orig_username'] : '';
$username = (isset($_REQUEST['username']))? trim($_REQUEST['username']) : $orig_username;
$password = (isset($_POST['password']))? $_POST['password'] : '';
$password2 = (isset($_POST['password2']))? $_POST['password2'] : '';
$real_name = (isset($_POST['real_name']))? trim($_POST['real_name']) : '';
$email = (isset($_POST['email']))? trim($_POST['email']) : '';
$default_filter = (isset($_POST['filter']))? $_POST['filter'] : '';
$have_group_in_user = (isset($_POST['groups']))? $_POST['groups'] : array();
$have_group_in_user[] = 'All';

$groupname = (isset($_REQUEST['groupname']))? trim($_REQUEST['groupname']) : '';

$simple = (isset($_GET['simple']))? $_GET['simple'] : '';
$type = (isset($_GET['type']))? $_GET['type'] : '';

$model = new UsersModel;

if ($action == "add_user" && $password !== '' && $password === $password2)
{
	Audit::track('add user', "Name: $username");
	$model->add_user($username, $password, $real_name, $email, $default_filter);
	foreach ($have_group_in_user as $group)
		$model->insert_user_group($username, $group);
}
elseif ($action == "save")
{
	Audit::track('edit user', "Name: $username");
	$success = true;

	if (($password !== '') && ($password2 !== '') && ($password === $password2))
		$model->set_password($username, $password);
	elseif ($password !== $password2)
		$success = false;

	if ($username !== $orig_username)
		$model->change_name($orig_username, $username);

	if ($real_name !== "")
		$model->change_real_name($real_name, $username);

	if ($email !== "")
		$model->change_email($email, $username);

	if ($username !== 'admin')
	{
		$group_in_user = $model->groups_in_user($username);

		$was_group_in_user = array();
		foreach ($group_in_user as $giu)
			$was_group_in_user[] = $giu['name'];

		$need_insert = array_diff ($have_group_in_user, $was_group_in_user);

		if (count($have_group_in_user) == 0)
			$need_delete = $was_group_in_user;
		else
			$need_delete = array_diff ($was_group_in_user, $have_group_in_user);

		$need_delete_str = "'".implode("','",$need_delete)."'";

		foreach ($need_insert as $group)
			$model->insert_user_group($username, $group);

		if (count($need_delete) > 0)
			$model->delete_user_group($username, $need_delete_str);
	}

	if ($default_filter !== '')
		$model->set_default_filter($default_filter, $username);

}
elseif ($action == "delete")
{
	Audit::track('delete user', "Name: $username");
	if ($username != "")
	{
		$model->delete_user($username);
		$deleted = true;
	}
}

if ($simple != "" && $type != "" && $groupname != "")
{
	if ($type == "in")
		$users = $model->users_in_group($groupname, false);
	elseif ($type == "out")
		$users = $model->users_out_group($groupname, false);
	else
		$users = $model->list_users();
}
else
{
	Audit::track('view users');
	$users = $model->list_users(false);
}
