var help = {
	'logs' : '<strong style="font-size: 12px">Search help</strong><br />'
		+ '<hr />To search for a message, simply type your search phrase in the'
		+ ' search form box and press Enter or click "Search now" button.<br />'
		+ 'By clicking on the Down arrow on the Search now button will allow'
		+ ' you to set a refresh period of the page.<br />If you want to define a more advanced'
		+ ' search query you can use the op5 Logserver query language or Query builder.<br /><br />'
		+ 'Select the filter you want to search with in "Search among" dropdown menu.'
		+ 'You can save your search query as a new filter by entering its name in'
		+ ' the "Save this search as" field and clicking Save button.<br />'
		+ 'Filter administors can make saved filter global by checking the global checkbox.<br /><br />'
		+ 'After selecting a filter in "Search among" dropdown menu you can edit or remove it,'
		+ ' or manage permissions for this filter by clicking on appropriate button.',
	'search' : '<strong style="font-size: 12px">Search help</strong><br />'
		+ '<hr />msg=connection<br />will search for any message including the string'
		+ '"connection"<br /><br />sev=(warn info) -(statistics daemon) -msg:"Log" -ident=sshd<br />'
		+ 'means: search for logs that have severity "warn" or "info", and do not'
		+ ' contain words "statistics" or "daemon" in any field, and where field'
		+ ' "msg" does not begin with "Log", and that were not generated by "sshd"<br />'
		+ '<br />Available fields: sev, fac, event, ip, ident, host, pid, msg<br />'
		+ 'Severities: emerg(ency), alert, crit(ical), err(or), warn(ing), notice,'
		+ ' info, debug<br />Facilities: kernel, user, mail, daemon, auth, syslog,'
		+ ' lpr, news, uucp, cron, authpriv, ftp, ntp, logaudit, logalert, clock2,'
		+ ' local0-7, mark<br /><br />For more information about the query language'
		+ ' see the <a href="/logserver/view?action=help">Help page</a>',
	'query_builder' : '<strong style="font-size: 12px">Query builder help</strong><br />'
		+ '<hr />Use this to create or edit the search queries.<br />'
		+ 'Fill in the values of the appropriate column you want to find in "is"/"contains" field,'
		+ ' and the values you want to skip in "is not"/"does not contain" field.'
		+ 'You can enter multiple values separated by space. If you need to enter the space'
		+ ' in the value - surround the value with the double quotes ("), e.g.:<br />'
		+ 'to find messages from local network except gateway that contains text'
		+ ' "login failed" you may use something like:<br />'
		+ '<ul><li>Source IP<ul><li>contains 192.168</li><li>does not contain 192.168.0.1</li></ul></li>'
		+ '<li>Message<ul><li>contains "login failed"</li></ul></li></ul>',
	'calendar' : '<strong style="font-size: 12px">Timeline help</strong><br />'
		+ '<hr />Select month/day/hour to start the search from.<br />'
		+ 'Use <img src="/logserver/images/icons/arrow-left.png" alt="\'Step back\'" />'
		+ ' and <img src="/logserver/images/icons/arrow-right.png" alt="\'Step forward\'" />'
		+ ' buttons to move back and forward rom the current results.<br />'
		+ 'Grayed out hours are archived. Click on them to be able to import them.<br />'
		+ 'After the hour is imported you can search in it.<br />'
		+ 'Gray bar represents the time frame current results belong to.',
	'results' : '<strong style="font-size: 12px">Results help</strong><br />'
		+ '<hr />Table shows you the results of search according to the query.'
		+ 'You can sort these results by any column(s) but this will not influence'
		+ ' your next searches.<br />Choose the columns to display by '
		+ '<img src="/logserver/images/icons/settings.png" alt="select columns" title="select columns" />'
		+ ' button.<br />Choose the number of results to display by '
		+ '<img src="/logserver/images/icons/settings-rows.png" alt="records per page" title="records per page" />'
		+ ' button.<br />Save these results as CSV file using <img src="/logserver/images/icons/csv.png" alt="export as .csv" title="export as .csv" />'
		+ ' button.',

	'manage_permissions' : '<strong style="font-size: 12px">Permissions help</strong><br />'
		+ '<hr />On the left pane you can see two lists of filters: Global filters'
		+ ' can be available to all users, My filters are your private filters'
		+ ' and nobody else can have access to them. You can make filter private or global'
		+ ' by moving it between these two lists.<br />'
		+ 'After selecting the global filter you will see users and groups that'
		+ ' can access it in Current users/groups lists. Move users/groups from the'
		+ ' Available lists to the Current lists to give them the same rights.'
		+ ' Move users/groups from the Current lists to the Available lists to remove'
		+ ' their access.',

	'reports' : 'The reports section of LogServer has two main functions:'
		+ '<ul><li>Auto reports: Does scheduled searches and sends them to a list of'
		+ ' users via e-mail or save them in a folder on your file server.</li>'
		+ '<li>Summary reports: Gives you top 10 hosts based on hits for each filter'
		+ ' you have access to, and create graph (message per minute) for global/private filters.</li></ul>',
	'report_name' : 'Short report name.',
	'report_description' : 'Long report description or any useful notes.',
	'report_filter' : 'Use the results of this filter for report.',
	'recipient_type' : 'Store reports on the server or send them by email.',
	'email_or_path' : 'Comma-separated list of email addresses, or a path on the server.',
	'interval' : 'Possible report intervals.',

	'global_filter' : 'Global filter to build the summary report for.',

	'report_user' : 'Owner of the private filter to build the summary report for.',
	'private_filter' : 'Private filter to build the summary report for.',

	'keep_in_db' : 'The time logs are kept in DB (and thus are available for search) before moving them to archive.',
	'local_path' : 'Path on the server where to store the local archive for the recent logs.',
	'keep_in_local' : 'Time the logs are considered recent and are kept in local archive.',
	'remote_path' : 'Path on the server where to store the remote archive for all needed logs. Usually the mount point to some big network storage.',
	'keep_in_remote' : 'Time the logs are concidered needed and are kept in remote archive.',
	'create_fts_index' : 'Increases the speed of queries with fulltext conditions. Turn it off if you have a lot of human unreadable logs.',
	'monitor_host' : 'Protocol (http or https) and Hostname or IP address of the host where op5 Monitor is installed. This can also be any other external host holding information about the logging hosts. (Example: http://192.168.1.x)',
	'use_monitor5' : 'Whether to use op5 Monitor 5/6 instead of op5 Monitor 4 for displaying host information.',
	'host_info_url' : 'URL of host information page on the monitor host, e.g.<br /><em>/monitor/cgi-bin/extinfo.cgi?type=1&amp;host=[host]</em><br />where <em>[host]</em> will be automatically replaced with a host name.<br />Leave this field empty if you want to use the default op5 Monitor or Ninja GUI.',

	'settings' : 'LogServer stores the logged data in three different locations:'
		+ '<ul><li>A local database for normal web access of latest data</li>'
		+ '<li>Compressed archive for longer term storage on local file system</li>'
		+ '<li>Compressed archive on remote file server for storage up to many years</li></ul>',

	'filters_import' : 'Select an XML file to import filters from. All filters will be imported as global.',
	'filters_export' : 'Select filters that will be exported to an XML file. All private filters will become global when imported from that file.',
	'ldap_mapping' : 'Enable/Disable LDAP or Active Directory login.  For each LDAP or AD group a set of corresponding logserver groups can be selected.',

	'admin' : 'Here you can create/edit/delete users/groups and manage user permissions.',
	'user_name' : 'User account in op5 LogServer (required).',
	'user_real_name' : 'User\'s real name.',
	'user_email' : 'User\'s email address.',
	'user_password' : 'Password: the user password (required).',
	'user_password2' : 'Repeat the password for safety (required).',
	'default_filter' : 'The filter that will be selected by default after user\'s login.',

	'group_name' : 'Short group name.',
	'group_description' : 'Long group description or any useful notes.',

	'help' : 'This is the help page containing usage instructions and a link to the manual. You also find a download link for the Windows agent.'
};
