<?php

class Audit
{
	private static $log = false;

	private static function open()
	{
		self::$log = openlog('logserver', 0, LOG_USER);

		if (self::$log === false)
			die('Could not connect to syslog!');
	}

	public static function track($action, $extra = '')
	{
		if (!self::$log)
			self::open();

		if (Auth::$username !== false)
			$user = Auth::$username;
		elseif ($_SERVER['REMOTE_ADDR'] == '127.0.0.1')
			$user = '<local>';
		else
			$user = '<unknown>';

		syslog(LOG_INFO, "[AUDIT] User: $user; Action: $action" . ($extra ? "; $extra" : ''));
	}
}
