<?php

class Auth
{
	protected static $_provider = NULL;
	protected static $_provider_list = array("db", "ldap");
	public static $username = false;
	private static $_ldap_config;
	private static $_ldap_connection;
	public static $is_admin = array(
		'user'     => false,
		'filter'   => false,
		'report'   => false,
		'import'   => false,
		'settings' => false,
		'summary'  => false
	);

	// TODO: move to proper place like UserModel
	private function register_if_user_exist($username) {
		
	}

	public function init($provider = "db")
	{
		session_set_cookie_params(0);
		session_start();

		if (!in_array($provider, self::$_provider_list)) {
			$provider = "db";
		}
		self::$_provider = $provider;

		$login = ""; $pwd = "";
		if (isset($_GET["auth_username"]) && isset($_GET["auth_hash"])) { 
			$login = $_GET["auth_username"];
			$pwd = $_GET["auth_hash"];
		} elseif (isset($_REQUEST['auth_username']) && isset($_REQUEST['auth_hash'])) {
			$login = $_REQUEST['auth_username'];
			$pwd = $_REQUEST['auth_hash'];
		}

		self::check($login, $pwd);

		if (isset($_SESSION["username"])) {
			self::$username = $_SESSION["username"];
			self::$is_admin = $_SESSION["is_admin"];
		}
	}

	public function check($username, $password)
	{
		if (NULL === self::$_provider) {
			throw new Exception("You should select provider.");
		}
		$method = "check_".self::$_provider;
		$ret_val = FALSE;
		switch(self::$_provider)
		{
			case 'ldap':
				$ret_val = self::check_ldap($username, $password);
				if ($ret_val) {
					$real_name = $username;
					$username = pg_escape_string("__ldap_user_$username");
					$usser_exist = Database::query("SELECT COUNT(\"id\") as \"isset\" FROM users WHERE name = ('$username');");
					if (intval($usser_exist[0]["isset"]) === 0) {
						Database::query("INSERT INTO users (name) VALUES ('$username');");
						Database::query("SELECT insert_usergroup('$username', 'All')");
					}
					if (self::$_ldap_config["LDAP_IS_AD"]) {
						$user_base = self::$_ldap_config["LDAP_USERS"];
						$res = ldap_search(self::$_ldap_connection, self::$_ldap_config["LDAP_GROUP"], "(&(objectClass=group)(member=cn=$real_name,{$user_base}))");
					} else {
						$res = ldap_search(self::$_ldap_connection, self::$_ldap_config['LDAP_GROUP'], ("(memberUid=$real_name)"));
					}
					$groups = ldap_get_entries(self::$_ldap_connection, $res);
					unset($groups["count"]);
					$res_groups = array();
					foreach ($groups as $value) {
						$tmp_v = explode(",", $value["dn"]);
						$tmp_v = explode("=", $tmp_v[0]);
						$res_groups[] = "'".$tmp_v[1]."'";
					}
					$groups_val = implode(", ", $res_groups);
					$db_res = Database::query("SELECT DISTINCT g.id, g.name FROM ldap_groups as lg LEFT JOIN ldap_groups_mapping as lgm ON lgm.ldap_group_id = lg.id LEFT JOIN groups as g ON g.id = lgm.group_id WHERE lg.name in ($groups_val) AND g.name <> '';");
					$map = array();
					$groups_id = array();
					foreach($db_res as $val) {
						$groups_id[] = $val["id"];
						$filter_name_part = explode(" ", $val["name"]);
						$filter_name_part = strtolower($filter_name_part[0]);
						if (isset(self::$is_admin[$filter_name_part])) {
							self::$is_admin[$filter_name_part] = true;
						}
					}
					require_once("comps/users/model.php");
					$model = new UsersModel();
					$uid = $model->get_id_by_name($username);
					$model->update_groups($uid, $groups_id);
					self::$username = $username;
					break;
				}
			case 'db':
				$ret_val = self::check_db($username, $password);
				if ($ret_val !== TRUE) {
					return FALSE;
				}
				self::$username = $username;
				foreach (array_keys(self::$is_admin) as $type) {
					self::$is_admin[$type] = self::is_admin($type, self::$username);
				}
		}
		$_SESSION["is_admin"] = self::$is_admin;
		$_SESSION["username"] = self::$username;

		return true;
	}

	public function check_db($username, $password) {
		$hash = md5($password);
		$result = Database::query("SELECT password FROM users WHERE name = '$username'");
		if (count($result) && $hash == $result[0]['password'])
		{

			self::$username = $username;

			foreach (array_keys(self::$is_admin) as $type)
				self::$is_admin[$type] = self::is_admin($type, self::$username);
			return true;
		}
		return false;
	}

	public function check_ldap($username, $password) {
		ldap_set_option(NULL, LDAP_OPT_DEBUG_LEVEL, 7);
		if (empty($username) || empty($password)) {
			return false;
		}

		$username = self::ldap_escape($username);

		if (($raw_config = @file('/opt/op5sys/etc/ldapserver')) === false) {
			return false;
		}

		$ldapbindpw = @file_get_contents('/opt/op5sys/etc/ldapbindpw');
		$ldapbindpw = chop($ldapbindpw);
		
		$config = array();
		foreach ($raw_config as $line) {
			$key = strtok(trim($line), '=');
			$value = strtok('');
			if ($key[0] != '#')
				$config[$key] = $value;
		}

		self::$_ldap_config = $config;

		if (!isset($config['LDAP_SERVER']) || !($ds = ldap_connect($config['LDAP_SERVER']))) {
			return false;
		}

		self::$_ldap_connection = $ds;

		if (isset($config['LDAP_IS_AD']) && $config['LDAP_IS_AD'] == '1' && isset($config['LDAP_UPNSUFFIX'])) {
			ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3); 
			ldap_set_option($ldap_conn,LDAP_OPT_REFERRALS, 0);
			if (@ldap_bind($ds, "{$username}@{$config['LDAP_UPNSUFFIX']}", $password)) {
				return true;
			}
		} else {
			if (!isset($config['LDAP_USERS']) || !isset($config['LDAP_USERKEY'])) {
				return false;
			}
			if (@ldap_bind($ds, "{$config['LDAP_USERKEY']}={$username},{$config['LDAP_USERS']}", $password)) {
				return true;
			} else {
				if(!empty($ldapbindpw)) {
					if (!@ldap_bind($ds, $config['LDAP_BIND_DN'], $ldapbindpw)) {
						return false;
					}
				}
				$search = ldap_search($ds, $config['LDAP_USERS'], "(&(|(objectClass=inetOrgPerson)(objectClass=posixAccount)(objectClass=account))({$config['LDAP_USERKEY']}={$username}))");
				if ($entries = ldap_get_entries($ds, $search)) {
					unset($entries["count"]);
					foreach ($entries as $entry) {
						if (@ldap_bind($ds, $entry["dn"], $password)) {
							return true;
						}
					}
				}
			}
		}

		return false;
	}

	private function ldap_escape($str, $from_dn = false)
	{
		$dn_ccodes = array(0x5c, 0x20, 0x22, 0x23, 0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x3b, 0x3c, 0x3e);
		$ccodes = array();
		foreach ($dn_ccodes as $ccode) {
			if ($from_dn)
				$ccodes['\\'.chr($ccode)] = $ccode;
			else
				$ccodes[chr($ccode)] = $ccode;
		}

		for ($i = 0; $i < 0x20; $i++) {
			if ($from_dn)
				$ccodes['\\'.chr($i)] = $i;
			else
				$ccodes[chr($i)] = $i;
		}

		foreach ($ccodes as $chr => $val) {
			if ($from_dn)
				$str = str_replace($chr, '\\'.$chr, $str);
			else
				$str = str_replace($chr, sprintf('\%02X', $val), $str);
		}

		$sf_ccodes = array(chr(0) => 0, chr(0x2a) => 0x2a, chr(0x28) => 0x28, chr(0x29) => 0x29);

		foreach ($sf_ccodes as $chr => $val)
			$str = str_replace($chr, sprintf('\%02X', $val), $str);

		return $str;
	}

	public function is_admin($type, $username)
	{
		$result = Database::query("SELECT * FROM show_user_groups('$username') WHERE name = '"
			. ucfirst($type) . (($type == "summary")? " viewers'" :  " administrators'"));

		return (count($result))? true : false;
	}
}
