<?php

class Database
{
	private static $dbh = false;

	private function connect()
	{
		self::$dbh = pg_connect('host=' . Config::dbhost . ' dbname=' . Config::dbname
			. ' user=' . Config::dbuser . " password='" . Config::dbpassword . "'");

		if (self::$dbh === false)
			throw new Exception('Could not connect to the database!');
	}

	public function query($sql)
	{
		if (!self::$dbh)
			self::connect();

		$query = pg_query(self::$dbh, $sql);

		if ($query === false)
			throw new Exception('Database query failed! ' . $sql);

		$result = pg_fetch_all($query);

		if ($result === false)
		{
			$rows = pg_affected_rows($query);
			if ($rows)
				$result = array_fill(0, $rows, true);
			else
				$result = array();
		}

		return $result;
	}
}
