function group_creation_finished()
{
	if (!$('#addgroupform table').length)
		return true;
	else if (confirm("You didn't finish group creation. Discard changes?"))
	{
		$('#addgroupform').hide();
		$('#addgroupform table').remove();
		$('#addnewgroup').parent().show();
		return true;
	}
	else
		return false;
}

function group_editing_finished()
{
	if (!$('#editgroupform').length)
		return true;
	else if (confirm("You didn't finish group editing. Discard changes?"))
	{
		$('#editrow').remove();
		$('tr:hidden').show();
		return true;
	}
	else
		return false;
}

function run_groups()
{
	var rxGroupName = /^([_.0-9A-Za-z])([- _.0-9A-Za-z]+)$/;

	function error(message)
	{
		alert(message);
		return false;
	}

	$('#addgroupform').hide();

	$('#addnewgroup').click(function(){
		if (!group_creation_finished() || !group_editing_finished())
			return false;

		$(this).parent().slideUp(50);

		$('#addgroupform').ajaxForm({
			target: '#list',
			beforeSubmit: function(){
				if (jQuery.trim($('#groupname').val()) == '')
					return error('Please enter group name.');

				if (!rxGroupName.test(jQuery.trim($('#groupname').val())))
					return error('Group name is invalid.');

				if ($('#list tr :first-child').filter(function(){
					if ($(this).text() == jQuery.trim($('#groupname').val()))
						return true;
					else
						return false;
				}).length)
					return error('Group with this name already exists.');
			},
			success: function(){
				$('#addgroupform').slideUp(500, function(){
					$('#addgroupform table').remove();
					$('#addnewgroup').parent().slideDown(50);
				});
			}
		});

		$('#addgroupform').load('/logserver/view/admin/groupform.inc.php', function(){
			$(this).slideDown(500);
			$('#groupname').focus();

			$('#action').val('add_group');
			$('#users_out').load('/logserver/comps/users?simple=1');

			$('#users_add').click(function(){
				$('#users_in').val('');
				$('#users_out option:selected').clone().prependTo('#users_in');
				$('#users_out option:selected').remove();
				return false;
			});

			$('#users_remove').click(function(){
				$('#users_out').val('');
				$('#users_in option:selected').clone().prependTo('#users_out');
				$('#users_in option:selected').remove();
				return false;
			});

			// THIS IS IMPORTANT!!!
			// otherwise only selected users will be passed
			$('#save').click(function(){
				$('#users_in option').attr('selected', 'selected');
			});

			$('#cancel').click(function(){
				$('#addgroupform').slideUp(500, function(){
					$('#addgroupform table').remove();
					$('#addnewgroup').parent().slideDown(50);
				});
				return false;
			});
		});

	});

	$('#list').load('/logserver/comps/groups');

	$('#list > .end').livequery(function(){
		$('#list table').tablesorter({sortList: [[0, 0]],
			headers: {3: {sorter: false}, 4: {sorter: false}}});

		$('.edit a').click(function(){
			if (group_creation_finished() && group_editing_finished())
			{
				var original = $(this).parent().parent();

				original.hide();
				original.after('<tr id="editrow"><td colspan="5"><form id="editgroupform" action="/logserver/comps/groups" method="post"></form></td></tr>');
				$('#editgroupform').hide();
				$('#editgroupform').load('/logserver/view/admin/groupform.inc.php', function(){
					$('#editgroupform').ajaxForm({
						target: '#list',
						beforeSubmit: function(){
							if (jQuery.trim($('#groupname').val()) == '')
								return error('Please enter group name.');

							if (!rxGroupName.test(jQuery.trim($('#groupname').val())))
								return error('Group name is invalid.');

							if ((jQuery.trim($('#groupname').val()) != $('#orig_groupname').val())
							&& $('#list tr :first-child').filter(function(){
								if ($(this).text() == jQuery.trim($('#groupname').val()))
									return true;
								else
									return false;
							}).length)
								return error('Group with this name already exists.');
						},
						success: function(){
							$('#cp_username').load('/logserver/comps/auth?action=get_username', function(){
								// send user out of admin page when (s)he's not an admin anymore
								if ($(this).children('span').length)
									window.location.replace('/logserver/');
							});
						}
					});

					$(this).slideDown(500);
					$('#groupname').focus();

					$('#action').val('save');
					$('#groupname').val(original.children().eq(0).text());
					$('#orig_groupname').val($('#groupname').val());

					// do not allow renaming system groups (important!)
					if (!$(original).children('.remove').length)
						$('#groupname').attr('disabled', 'disabled');

					$('#description').val(original.children().eq(2).text());
					$('#users_in').load('/logserver/comps/users?simple=1&groupname=' + $('#groupname').val().replace(/ /g, '+') + '&type=in');
					$('#users_out').load('/logserver/comps/users?simple=1&groupname=' + $('#groupname').val().replace(/ /g, '+') + '&type=out');

					$('#users_add').click(function(){
						$('#users_in').val('');
						$('#users_out option:selected').clone().prependTo('#users_in');
						$('#users_out option:selected').remove();
						return false;
					});

					$('#users_remove').click(function(){
						$('#users_out').val('');
						/* instead of this simple code:
						$('#users_in option:selected').clone().prependTo('#users_out');
						$('#users_in option:selected').remove();
						this ugly hack is needed due to IE7 does not support disabled attribute for options!!! >:-E
						*/
						$('#users_in option:selected').filter(function(){
							if ($(this).text() == 'admin')
								return false;
							else
								return true;
						}).clone().prependTo('#users_out');
						$('#users_in option:selected').filter(function(){
							if ($(this).text() == 'admin')
								return false;
							else
								return true;
						}).remove();
						return false;
					});

					// THIS IS IMPORTANT!!!
					// otherwise only selected users will be passed
					$('#save').click(function(){
						$('#users_in option').attr('selected', 'selected');
					});

					$('#cancel').click(function(){
						$('#editgroupform').slideUp(500, function(){
							$('#editrow').remove();
							original.show();
						});
						return false;
					});
				});
			}

			return false;
		});
		$('#list > table td').dblclick(function(){
			$(this).parent().children('.edit').children('a').click();
			return false;
		});

		$('.remove a').click(function(){
			if (group_creation_finished() && group_editing_finished())
			{
				var groupname = $(this).parent().siblings().eq(0).text();

				//$('tr.msg').remove();
				if (confirm("Remove group '" + groupname + "'?"))
					$('#list').load('/logserver/comps/groups?action=delete&groupname=' + groupname.replace(/ /g, '+'), function(){
						//$('#...').prepend('<tr class="msg ok"><th colspan="2">Group has been deleted.</th></tr>');
					});
			}

			return false;
		});
	});
};
