function user_creation_finished()
{
	if (!$('#adduserform table').length)
		return true;
	else if (confirm("You didn't finish user creation. Discard changes?"))
	{
		$('#adduserform').hide();
		$('#adduserform table').remove();
		$('#addnewuser').parent().show();
		return true;
	}
	else
		return false;
}

function user_editing_finished()
{
	if (!$('#edituserform').length)
		return true;
	else if (confirm("You didn't finish user editing. Discard changes?"))
	{
		$('#editrow').remove();
		$('tr:hidden').show();
		return true;
	}
	else
		return false;
}

function update_filters(username, callback)
{
	var groups = new Array;

	$('#groups_in option').each(function(){
		groups.push($(this).text());
		return true;
	});

	$('#filter_container').load('/logserver/comps/filters?simple=1&action=get_visible&username='
		+ username.replace(/ /g, '+') + '&groups=' + groups.join('|').replace(/ /g, '+'), callback);
}

function run_users()
{
	var rxUserName = /^([_.0-9A-Za-z])([- _.0-9A-Za-z]+)$/;

	function error(message)
	{
		alert(message);
		return false;
	}

	$('#adduserform').hide();

	$('#addnewuser').click(function(){
		if (!user_creation_finished() || !user_editing_finished())
			return false;

		$(this).parent().slideUp(50);

		$('#adduserform').ajaxForm({
			target: '#list',
			beforeSubmit: function(){
				if (jQuery.trim($('#username').val()) == '')
					return error('Please enter user name.');

				if (!rxUserName.test(jQuery.trim($('#username').val())))
					return error('Username is invalid.');

				if ($('#list tr :first-child').filter(function(){
					if ($(this).text() == jQuery.trim($('#username').val()))
						return true;
					else
						return false;
				}).length)
					return error('User with this name already exists.');

				if (!jQuery.trim($('#email').val()) != '')
					return error('Email is invalid.');

				if (jQuery.trim($('#password').val()) == '' || jQuery.trim($('#password2').val()) == '')
					return error('Password cannot be empty.');

				if ($('#password').val() != $('#password2').val())
					return error('You have entered two different passwords!');
			},
			success: function(){
				$('#adduserform').slideUp(500, function(){
					$('#adduserform table').remove();
					$('#addnewuser').parent().slideDown(50);
				});
			}
		});

		$('#adduserform').load('/logserver/view/admin/userform.inc.php', function(){
			$(this).slideDown(500);
			$('#username').focus();

			$('#action').val('add_user');
			update_filters('', function(){
				if (!$('#filter_container option').length)
					$('#filter_container').html('<select id="filter" name="filter" class="normal"><optgroup label="No filters available for this user."></optgroup><optgroup label="Assign groups to give permission to use filters."></optgroup></select>');
			});
			$('#groups_out').load('/logserver/comps/groups?simple=1');

			$('#groups_add').click(function(){
				$('#groups_in').val('');
				$('#groups_out option:selected').clone().prependTo('#groups_in');
				$('#groups_out option:selected').remove();
				update_filters('');
				return false;
			});

			$('#groups_remove').click(function(){
				$('#groups_out').val('');
				$('#groups_in option:selected').clone().prependTo('#groups_out');
				$('#groups_in option:selected').remove();
				update_filters('');
				return false;
			});

			// THIS IS IMPORTANT!!!
			// otherwise only selected groups will be passed
			$('#save').click(function(){
				$('#groups_in option').attr('selected', 'selected');
			});

			$('#cancel').click(function(){
				$('#adduserform').slideUp(500, function(){
					$('#adduserform table').remove();
					$('#addnewuser').parent().slideDown(50);
				});
				return false;
			});
		});

	});

	$('#list').load('/logserver/comps/users');

	$('#list > .end').livequery(function(){
		$('#list table').tablesorter({sortList: [[0, 0]],
			headers: {5: {sorter: false}, 6: {sorter: false}}});

		$('.edit a').click(function(){
			if (user_creation_finished() && user_editing_finished())
			{
				var original = $(this).parent().parent();

				original.hide();
				original.after('<tr id="editrow"><td colspan="7"><form id="edituserform" action="/logserver/comps/users" method="post"></form></td></tr>');
				$('#edituserform').hide();
				$('#edituserform').load('/logserver/view/admin/userform.inc.php', function(){
					$('#edituserform').ajaxForm({
						target: '#list',
						beforeSubmit: function(){
							if (jQuery.trim($('#username').val()) == '')
								return error('Please enter user name.');

							if (!rxUserName.test(jQuery.trim($('#username').val())))
								return error('Username is invalid.');

							if ((jQuery.trim($('#username').val()) != $('#orig_username').val())
							&& $('#list tr :first-child').filter(function(){
								if ($(this).text() == jQuery.trim($('#username').val()))
									return true;
								else
									return false;
							}).length)
								return error('User with this name already exists.');

							if ($('#email').val().indexOf('@') === -1)
								return error('Email is invalid.');

							if ($('#password').val() != $('#password2').val())
								return error('You have entered two different passwords!');
						},
						success: function(){
							$('#cp_username').load('/logserver/comps/auth?action=get_username', function(){
								// send user out of admin page when (s)he's not an admin anymore
								if ($(this).children('span').length)
									window.location.replace('/logserver/');
							});
						}
					});

					$(this).slideDown(500);
					$('#username').focus();

					$('#action').val('save');
					$('#username').val(original.children().eq(0).text());
					$('#orig_username').val($('#username').val());

					if ($('#username').val() == 'admin')
					{
						$('#username').attr('disabled', 'disabled');
						$('#groups_in').attr('disabled', 'disabled');
						$('#groups_out').attr('disabled', 'disabled');
					}

					$('#real_name').val(original.children().eq(1).text());
					$('#email').val(original.children().eq(2).text());
					$('#groups_in').load('/logserver/comps/groups?simple=1&username=' + $('#username').val().replace(/ /g, '+') + '&type=in', function(){
						update_filters($('#orig_username').val(), function(){
							$('#filter').val(original.children().eq(4).text());
						});
					});
					$('#groups_out').load('/logserver/comps/groups?simple=1&username=' + $('#username').val().replace(/ /g, '+') + '&type=out');

					$('#groups_add').click(function(){
						$('#groups_in').val('');
						$('#groups_out option:selected').clone().prependTo('#groups_in');
						$('#groups_out option:selected').remove();
						var prev_filter = $('#filter').val();
						update_filters($('#orig_username').val(), function(){
							$('#filter option').each(function(){
								if ($(this).text() == prev_filter)
								{
									$(this).select();
									return false;
								}
								else
									return true;
							});
							if (!$('#filter_container option').length)
								$('#filter_container').html('<select id="filter" name="filter" class="normal"><optgroup label="No filters available for this user."></optgroup><optgroup label="Assign groups to give permission to use filters."></optgroup></select>');
						});
						return false;
					});

					$('#groups_remove').click(function(){
						$('#groups_out').val('');
						$('#groups_in option:selected').clone().prependTo('#groups_out');
						$('#groups_in option:selected').remove();
						var prev_filter = $('#filter').val();
						update_filters($('#orig_username').val(), function(){
							$('#filter option').each(function(){
								if ($(this).text() == prev_filter)
								{
									$(this).select();
									return false;
								}
								else
									return true;
							});
						});
						return false;
					});

					// THIS IS IMPORTANT!!!
					// otherwise only selected groups will be passed
					$('#save').click(function(){
						$('#groups_in option').attr('selected', 'selected');
					});

					$('#cancel').click(function(){
						$('#edituserform').slideUp(500, function(){
							$('#editrow').remove();
							original.show();
						});
						return false;
					});
				});
			}

			return false;
		});
		$('#list > table td').dblclick(function(){
			$(this).parent().children('.edit').children('a').click();
			return false;
		});

		$('.remove a').click(function(){
			if (user_creation_finished() && user_editing_finished())
			{
				var username = $(this).parent().siblings().eq(0).text();

				//$('tr.msg').remove();
				if (confirm("Remove user '" + username + "'?"))
					$('#list').load('/logserver/comps/users?action=delete&username=' + username.replace(/ /g, '+'), function(){
						//$('#...').prepend('<tr class="msg ok"><th colspan="2">User has been deleted.</th></tr>');
					});
			}

			return false;
		});
	});
};
