<div id="header">
	<h1>Help</h1>
	<p>
		op5 LogServer
		<img src="/logserver/images/icons/arrow-red-right.gif" alt="&raquo;" />
		Help
	</p>
</div>
<div id="last_status"></div>
<div id="main-box">
	<div id="main-content">
<p>
<b><img src="/logserver/images/icons/doc_pdf.png" alt="" style="vertical-align: top;" /> <a href="/logserver/view/help/logserver-manual.pdf" target="_blank">LogServer Manual in PDF format</a></b>
<br /><br />
<b><img src="/logserver/images/icons/download.png" alt="" style="vertical-align: top;" /> <a href="http://www.op5.com/support/downloads/agents/windows-syslogagent" target="_blank">Windows Syslog Agent</a></b>
<br />This agent converts Windows eventlog messages and sends them to op5 LogServer<br /></p>
<pre style="font-family: monospace;">
<b>View</b>
----
On this page you can view and search your log messages. The page is divided in three parts,
search, calendar and the actual logs.

To search for a message, simply type your search phrase in the search form box and press enter.
If you want to define a more advanced search query you can use the op5 Logserver query language,
or Query builder.

<b>Query Language</b>
<u><b>column</b></u>          <u><b>query</b></u>                <u><b>descriptor</b></u>
Severity        sev|severity        (=)
Facility        fac|facility        (=)
Event ID        event|event_id      (=)
Src IP          ip|src_ip           (=) (:) (~)
Ident           ident               (=) (:) (~)
Host            host                (=) (:) (~)
PID             pid                 (=)
Message         msg|message         (=) (:) (~)

<b>Examples:</b>
msg=connection
will search for any message including the string "connection"

sev=(warn info) -(statistics daemon) -msg:"Log" -ident=sshd
means: search for logs that have severity "warn" or "info",
and do not contain words "statistics" or "daemon" in any field,
and where field "msg" does not begin with "Log",
and that were not generated by "sshd"

host~"192.168.1.(97|158)" -msg~"^(root) CMD"
matches host 192.168.1.97 or 158 and messages not starting with "(root) CMD"

msg~"UserName:\x09([[:alnum:]$_-])*[^$] "
matches msg that contains "UserName:&lt;tab&gt;username" and username does not end with $

<b>Available fields:</b> sev, fac, event, ip, ident, host, pid, msg
Severities: emerg(ency), alert, crit(ical), err(or), warn(ing), notice, info, debug
Facilities: kernel, user, mail, daemon, auth, syslog, lpr, news, uucp, cron, authpriv,
            ftp, ntp, logaudit, logalert, clock2, local0-7, mark

Advanced search tip: using the ~ operator enables regular expresion searches.
To save your search, type a name for it in the "Save this search as" form box and press "Save".
The search are now available in the drop down list to the right of the "Search" form box.
Tip: you can search within saved searches.

The calendar is used to brows logs over time. By default the latest received log messages are
displayed. If you want to browse, simply select month, day and hour. Black hours means that
the logs lives in the database and are quickly accessable for viewing and searching,
grey hours meens that the logs are stored on disk (local or remote storage) and needs importing.
To import just click on the gray hour.

The log messages are displayed in the table below. The available columns are

* Severity, A color code that indicates the severity of the log message
* Facility, The  facility  is  one of the following keywords: auth, authpriv, cron,
daemon, kern, lpr, mail, mark, news, security (same as  auth),  syslog,
user, uucp and local0 through local7.
* Event ID, event id received from windows servers
* Src IP, source ip of the log sender
* Ident, usually the name of the program that generated the log message
* Host, hostname of the log sender
* PID, process ID
* Message, the actual log message

<b>Reports</b>
-------
Create scheduled reports to send or store filter search results. The reports can either be
sent to email recipient(s) or stored on the file system.

note: The reports are only created based on the data existing in the database, if you use a
report interval that are wider than the content of the database it will still only include the
data in the database.

<b>Settings</b>
--------
Here you can change settings for the log database and storage of logs.

When op5 Logserver receives logs it stores them in database, local storage and remote storage.
Data available in the database is quickly searchable, data in local and remote storage needs to
be imported before it can be searched.


<b>Users &amp; Groups</b>
-----
Add, delete and edit users and groups.

<b>Help</b>
----
This page
</pre>
	</div>
</div>
