<?php

/* $view is set by frontend controller */

$menu['logs'] = 'View';
if (Auth::$is_admin['report'] || Auth::$is_admin['summary'] || Auth::$is_admin['filter'])
	$menu['reports'] = 'Reports';
if (Auth::$is_admin['settings'])
	$menu['settings'] = 'Settings';
if (Auth::$is_admin['user'])
	$menu['admin'] = 'Users &amp; Groups';
$menu['portal'] = 'Portal';
$menu['help'] = 'Help';

/* license bar ************************************************************************************/

	require_once('/opt/op5sys/lib/php/op5license.php');

	$license = new op5license();
	$license->register_product('Logserver');
	$license->check();

	if($license->status() != OP5LICENSE_CHECK_OK)
		$body_onload = ' onload="init();' . (($view != 'settings')? 'Custom.initstyle();' : '') . '"';
	else
		$body_onload = ($view != 'settings')? ' onload="Custom.initstyle();"' : ' ';

	$is_ldap = preg_match("/^__ldap_user_/", Auth::$username);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="Content-type" content="application/xhtml+xml; charset=utf-8" />
		<title> op5 LogServer </title>
		<script type="text/javascript" src="/logserver/js/custom-form-elements.js"></script>
		<link type="text/css" rel="stylesheet" href="/logserver/css/common.css" />
		<link type="text/css" rel="stylesheet" href="/logserver/css/buttons.css" />
		<link type="text/css" rel="stylesheet" href="/logserver/css/colours.css" />
		<link type="text/css" rel="stylesheet" href="/logserver/css/clickmenu.css" />
		<?php if (file_exists("/opt/logserver/gui/css/$view.css")) { ?>
		<link type="text/css" rel="stylesheet" href="<?php echo "/logserver/css/$view.css"; ?>" />
		<?php } ?>
		<script type="text/javascript" src="/logserver/js/script.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.form.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.livequery.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.clickmenu.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.cookie.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.columnmanager.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.tablesorter.js"></script>
		<script type="text/javascript" src="/logserver/js/jquery.scrollto.js"></script>
		<script type="text/javascript" src="/logserver/js/popups.js"></script>
		<script type="text/javascript" src="/logserver/js/help.js"></script>
		<?php if (file_exists("/opt/logserver/gui/view/$view/client.js")) { ?>
		<script type="text/javascript" src="<?php echo "/logserver/view/$view/client.js"; ?>"></script>
		<?php } ?>
		<script type="text/javascript">
			$.ajaxSetup({
				cache: false
			});

			function refresh_session() {
				clearInterval(sessionTimer);
				// refresh session
				$('#cp_username').load('/logserver/comps/auth?action=get_username&refresh=1', function(){
					sessionTimer = setInterval(refresh_session, 60000);
				});
			}

			function refresh_date(){
				clearInterval(dateTimer);
				// refresh date
				$('#date').load('/logserver/comps/auth?action=get_date', function(){
					dateTimer = setInterval(refresh_date, 60000);
				});
			}

			function refreshInfo () {
				$.get("/logserver/comps/auth?action=get_info",
					{},
					function (data) {
						data.version = data.version.replace(/\n/, '');
						$("#version").html(data.version);
						$("#count").html(data.count);
						$("#date").html(data.date);
						$("#cp_username").html(data.username);
						setTimeout(refreshInfo, 30000);
					},
					"json"
				);
			}

			$(document).ready(function(){
				//$('#version').load('/logserver/comps/auth?action=get_version');
				//$('#count').load('/logserver/comps/auth?action=get_count');

				refreshInfo();

				$('#cp_username').click(function(){
					$('body').append('<div id="change_password_popup"></div>');
					$('#change_password_popup').load('/logserver/comps/info', function(){
						$('#dim').css('height', $(document).height() + 'px');
					});
					return false;
				});
				$('#change_password').livequery(function(){
					$(this).click(function(){
						$('#changepasswordform').ajaxSubmit({target: '#change_password_popup', success: function(){
							$('input').focus(function(){
								$('tr.msg').remove();
							});
						}});
						return false;
					});
				});
				$('#close_changing_password_popup').livequery(function(){
					$(this).click(function(){
						$('#change_password_popup').remove();
						return false;
					});
				});
				$('#cancel_changing_password').livequery(function(){
					$(this).click(function(){
						$('#change_password_popup').remove();
						return false;
					});
				});
				//sessionTimer = setInterval(refresh_session, 60000); // every 60 seconds
				//dateTimer = setInterval(refresh_date, 1);
			});

			function init() {
				document.getElementById('container').style.top = '30px';
			}
		</script>
	</head>

	<body<?php echo $body_onload; ?>>
		<?php echo $license->print_license_bar(); ?>
		<div id="container">

		<div id="menu">
			<ul>
				<li class="logo"><img src="/logserver/images/icons/op5.png" alt="" /></li>
				<?php
				$search = array(' ','&amp;');
				$replace = array('_','and');
				foreach ($menu as $url => $title)
				{
					if ($url == "portal")
					{
						echo '<li onclick="location.href=\'/\'"><img src="/logserver/images/menu/'.str_replace($search,$replace,strtolower($title)).'.png" alt=""> &nbsp;<a href="/">'.$title.'</a></li>'."\n";
					}
					else
						echo ($url == $view)?
							('<li class="selected"><img src="/logserver/images/menu/selected/'.str_replace($search,$replace,strtolower($title)).'.png" alt=""> &nbsp;<a href="#" onclick="return false;">' . $title . '</a></li>')
							: ('<li onclick="location.href=\'/logserver/view/' . $url . '\'"><img src="/logserver/images/menu/'.str_replace($search,$replace,strtolower($title)).'.png" alt=""> &nbsp;<a href="/logserver/view/' . $url . '">' . $title . '</a></li>');
				}
				?>
				<li class="logout" style="cursor: default">
				<form id="logoutform" action="/logserver/comps/auth" method="post"><input type="hidden" name="action" value="logout" /></form>
				Welcome <?php if ($is_ldap) { ?>
					<span id="cp_username_ldap"><?php echo preg_replace("/^__ldap_user_/", "", Auth::$username);?></span>
					<?php } else { ?><a id="cp_username"><?php print Auth::$username ?></a><?php } ?> &nbsp;|&nbsp; <a href="#" id="logout" onclick="$('#logoutform').submit(); return false;">Log out</a>
				</li>
			</ul>
		</div>
		<div id="topbar">
			<div id="status">
				<img src="/logserver/images/bg/menu-divider.gif" alt="" style="margin-right: 7px" />
				Rows in database:&nbsp;<span id="count"></span>&nbsp;&nbsp;Date:&nbsp;<span id="date"></span>&nbsp;&nbsp;Version:&nbsp;<span id="version"></span>
				<img src="/logserver/images/bg/menu-divider.gif" alt="" style="margin-bottom: -6px; margin-right: 7px; margin-left:7px" />
				<a id="help_<?php echo $view; ?>" class="help2 topbar" href="#"><img src="/logserver/images/menu/help.png" alt="" title="Help" /></a>
			</div>
		</div>

		<?php require_once("$view/index.php"); ?>
	</body>
</html>
