var tailTimer = 0;
var importTimer = 0;
var importList = Array();

var g_disabled = true; /* true disables all UI except Stop search */
var g_stop_search = false; /* when true - no additional search requests will be sent */
var g_search_in_progress = true;

var g_filter = '';
var g_table = ''; /* this is a table from which a new search will start (highlighted in GUI) */
var g_limit = 75;
var g_direction = 'backwards';
var g_inquiring = false; /* true after the first reply, false after the last reply */

/* left part of time frame */
var g_begin_table = '';
var g_begin_offset = 0;
var g_begin_prev = '';
var g_begin_next = '';
var g_begin_time = '';

/* right part of time frame */
var g_end_table = '';
var g_end_offset = -75;
var g_end_prev = '';
var g_end_next = '';
var g_end_time = '';

/* rtime of the first and the last message in the results table */
g_time_from = '';
g_time_to = '';

function get_current_time()
{
	var now = new Date();
	return (now.getFullYear() + '-'
		+ ((now.getMonth() < 9)? '0' : '') + (now.getMonth() + 1) + '-'
		+ ((now.getDate() < 10)? '0' : '') + now.getDate() + ' '
		+ ((now.getHours() < 10)? '0' : '') + now.getHours() + ':'
		+ ((now.getMinutes() < 10)? '0' : '') + now.getMinutes() + ':'
		+ ((now.getSeconds() < 10)? '0' : '') + now.getSeconds());
}

function new_results()
{
	$('#table_buttons').hide();
	$('#results table').remove();

	$('#results div:last').html('<table summary="Logdata table" class="max">'
		+ '<thead><tr class="header">'
		+ '<th>Severity</th>'
		+ '<th>Facility</th>'
		+ '<th>Recv Time</th>'
		+ '<th>Msg Time</th>'
		+ '<th>Event ID</th>'
		+ '<th>Src IP</th>'
		+ '<th>Ident</th>'
		+ '<th>Host</th>'
		+ '<th>PID</th>'
		+ '<th>Message</th>'
		+ '</tr></thead><tbody></tbody></table>');

	/* work around disappearing menu issue */
	$('#divSelectColumn').html('<ul id="ulSelectColumn"><li><img src="/logserver/images/icons/settings.png"'
		+ ' alt="select columns" title="select columns"	/><ul id="column_picker"></ul></li></ul>');

	$('#results table').columnManager({
		listTargetID: 'column_picker',
		onClass: 'advon',
		offClass: 'advoff',
		saveState: true
	});
	$('#ulSelectColumn').clickMenu({onClick: function(){}});

	$('#results h1 span').eq(0).text($('#i_query').val());
	$('#results h1 span').eq(1).text($('#i_filter').val());
	$('#results h1 span').eq(2).text($('#i_limit').val() || g_limit );
}

function reset_search_notifier()
{
	if (!tailTimer)
	{
		if (g_table == '')
			$('#search_notifier').html('Search from the end of database');
		else
		{
			$('#search_notifier').html('Search from '
				+ g_table.substr(0, 10).replace(/_/g, '-') + ' '
				+ g_table.substr(11, 2) + ':00:00');
		}
	}
}

function do_search(type)
{
	/* alert('[ ' + g_begin_table + ':' + g_begin_offset + ' ... ' + g_end_table + ':' + g_end_offset + ' ]'); /* DEBUG */
	if (type == 'tail')
		$('#last_status').append('<p>Tail search started.</p>');
	else if (g_direction == 'forward')
		$('#last_status').append('<p>Forward search started from ' + g_begin_time + '</p>');
	else
		$('#last_status').append('<p>Backward search started from ' + g_end_time + '</p>');

	$('#last_status').scrollTo($('#last_status p:last'), {axis: 'y', margin: true, duration: 100});

	if (!tailTimer)
		$('#search_notifier').html('<img src="/logserver/images/icons/indicator.gif" alt="" /> Searching... <a href="#">Stop</a>');

	g_search_in_progress = true;
	$('#inquireform').ajaxSubmit({target: '#inquire'});
}

function new_search()
{
	$('#i_table').val(g_table);
	$('#i_offset').val(0);
	$('#i_limit').val(g_limit);
	g_direction = 'forward';
	$('#i_direction').val('forward');
	g_begin_table = g_table;
	g_begin_offset = 0;
	g_begin_prev = '';
	g_begin_next = '';
	g_begin_time = g_begin_table.substr(0, 10).replace(/_/g, '-')
		+ ' ' + g_begin_table.substr(11, 2) + ':00:00';
	g_disabled = true;
	new_results();
	do_search('normal');
}

function tail_search()
{
	g_table = '';
	$('#i_table').val('');
	$('#i_offset').val(0);
	$('#i_limit').val(g_limit);
	g_direction = 'backwards';
	$('#i_direction').val('backwards');
	g_end_table = '';
	g_end_offset = 0;
	g_end_prev = '';
	g_end_next = '';
	g_end_time = '';
	g_disabled = true;
	new_results();
	do_search('tail');
}

function search_next()
{
	if (g_disabled) return false;
	/* alert(g_begin_table + ':' + g_begin_offset + ' ... ' + g_end_table + ':' + g_end_offset); /* DEBUG */
	if (g_begin_offset != g_end_offset && g_end_table)
	{
		cancelTail();
		$('#i_table').val(g_end_table);
		g_begin_time = g_end_time;
		if (g_end_offset >= 0)
		{
			$('#i_direction').val('forward');
			$('#i_offset').val(g_end_offset);
			$('#i_limit').val(g_limit);
		}
		else
		{
			var new_offset = g_end_offset + g_limit;

			$('#i_direction').val('backwards');
			if (new_offset > 0)
			{
				$('#i_offset').val(0);
				$('#i_limit').val(Math.abs(g_end_offset));
			}
			else
			{
				$('#i_offset').val(new_offset);
				$('#i_limit').val(Math.abs(g_end_offset) - Math.abs(new_offset));
			}
		}
		g_direction = 'forward';
		g_begin_table = g_end_table;
		g_begin_offset = g_end_offset;
		g_disabled = true;
		new_results();
		/* alert('starting'); /* DEBUG */
		do_search('normal');
	}

	return false;
}

function search_prev()
{
	if (g_disabled) return false;
	/* alert(g_begin_table + ':' + g_begin_offset + ' ... ' + g_end_table + ':' + g_end_offset); /* DEBUG */
	if (g_begin_table && !(g_begin_offset == 0 && g_begin_prev == ''))
	{
		cancelTail();
		if (g_begin_offset == 0)
			$('#i_table').val(g_begin_prev);
		else
			$('#i_table').val(g_begin_table);

		g_end_time = g_begin_time;
		g_end_table = g_begin_table;
		g_end_offset = g_begin_offset;
		g_direction = 'backwards';
		if (g_begin_offset <= 0)
		{
			$('#i_direction').val('backwards');
			$('#i_offset').val(g_begin_offset);
			$('#i_limit').val(g_limit);
		}
		else
		{
			var new_offset = g_begin_offset - g_limit;

			if (new_offset < 0)
				new_offset = 0;

			$('#i_direction').val('forward');
			$('#i_offset').val(new_offset);
			$('#i_limit').val(g_begin_offset - new_offset);
		}
		g_disabled = true;
		new_results();
		/* alert('starting'); /* DEBUG */
		do_search('normal');
	}

	return false;
}

function cancelTail()
{
	if (!tailTimer)
		return;

	clearInterval(tailTimer);
	tailTimer = 0;
	reset_search_notifier();
}

function checkImport()
{
	if (importList.length)
		$('#import_status').load('/logserver/comps/import', {check: importList.join(',')}, function(){
			for (var i = 0; i < importList.length; i++)
			{
				var index = $('#import_status').text().indexOf(importList[i]);
				if (index != -1)
				{
					if ($('#import_status').text().substr(index - 1, 1) == '+')
					{
						$('#last_status').append('<p id="imported_' + importList[i] + '">' + importList[i] + ' has been imported.</p>');
						$('#last_status').scrollTo($('#imported_' + importList[i]), {axis: 'y', margin: true, duration: 100});
						$('#month_' + importList[i].substr(0, 7)).removeClass('in_archive');
						$('#month_' + importList[i].substr(0, 7)).addClass('in_db');
						if (importList[i].substr(0, 7) == $('#month').val())
						{
							$('#day_' + importList[i].substr(8, 2)).removeClass('in_archive');
							$('#day_' + importList[i].substr(8, 2)).addClass('in_db');
							if (importList[i].substr(8, 2) == $('#day').val())
							{
								$('#hour_' + importList[i].substr(11, 2)).removeClass('in_archive');
								$('#hour_' + importList[i].substr(11, 2)).removeClass('importing');
								$('#hour_' + importList[i].substr(11, 2)).addClass('in_db');
								$('#hour_' + importList[i].substr(11, 2)).addClass('normal');
								// Note: .attr('class', 'in_db normal') cannot be used
								// because .current_hour will be deleted
							}
						}
					}
					else if ($('#import_status').text().substr(index - 1, 1) == '!')
					{
						$('#last_status').append('<p id="imported_' + importList[i] + '">' + importList[i] + ' has failed.</p>');
						$('#last_status').scrollTo($('#imported_' + importList[i]), {axis: 'y', margin: true, duration: 100});
						if (importList[i].substr(0, 7) == $('#month').val()
							&& importList[i].substr(8, 2) == $('#day').val())
						{
							$('#hour_' + importList[i].substr(11, 2)).removeClass('importing');
							$('#hour_' + importList[i].substr(11, 2)).addClass('failed');
						}
					}
					importList.splice(i, 1);
					i--;
				}
			}

			if (importTimer)
				clearInterval(importTimer);
			if (importList.length)
				importTimer = setInterval(checkImport, 10000);
		});
}

function update_hierarchy()
{
	$('#filter').val(g_filter);
	$('#hierarchy').load('/logserver/comps/filters?action=get_parents&filter='
		+ g_filter.replace(/ /g, '+'), function()
	{
		$(this).children('a:not(.button)').click(function(){
			if (g_disabled) return false;
			g_filter = $(this).text();
			update_hierarchy();
			return false;
		});
	});
}

function setup_filter_picker(){
	$('body').append('<div id="filter_picker" class="hidden persistent_popup"></div>');
	$('#filter_picker').load('/logserver/comps/filters', function(){
		if ($('#preselected_filter').length)
			g_filter = $('#preselected_filter').text();
		else if ($('#default_filter').length)
			g_filter = $('#default_filter').text();
		else
			g_filter = $('#filter_picker li a:first').text();

		update_hierarchy();

		$('#filter_picker li a').livequery('click', function(){
			g_filter = $(this).text();
			$('#filter_picker').addClass('hidden');
			$('#filter_picker').removeAttr('style');
			update_hierarchy();
			return false;
		});
	});
	$('#close_filter_picker').livequery('click', function(){
		$('#filter_picker').addClass('hidden');
		$('#filter_picker').removeAttr('style');
		return false;
	});
	$('#search_among, #filter_picker_toggle').click(function(){
		if (g_disabled) return false;
		if ($('#filter_picker').hasClass('hidden'))
		{
			close_popups();
			$('#filter_picker').attr('style', 'position: absolute; left: '
				+ $('#search_among').offset().left + 'px; top: '
				+ ($('#search_among').offset().top + 16) + 'px; width: '
				+ $('#filter_picker').children('div').length * 200 + 'px;');
			$('#filter_picker').removeClass('hidden');
			$('#filter_picker li a:first').focus();
		}
		else
		{
			$('#filter_picker').addClass('hidden');
			$('#filter_picker').removeAttr('style');
		}
		return false;
	});
}

function remove_timeframe(){
	if ($('.current_hour').length)
		unhighlight_hour($('.current_hour'));
	$(window).unbind('resize');
	$('#time_frame').remove();
	$('#time_bar').remove();
}

function render_timeframe(){
	if (!$('#hours').children('ul').length)
		return false;

	var current_date = $('#month').val().replace(/_/, '-') + '-' + $('#day').val();

	if (current_date < g_begin_time.substr(0, 10) || current_date > g_end_time.substr(0, 10))
		return false;

	if (!$('#time_bar').length)
		$('body').append('<div id="time_bar" style="position: absolute; top: '
			+ ($('#hours a:first').offset().top - 3) + 'px; display: none;"></div>');
	else
	{
		$('#time_bar').hide();
		$('#time_bar').empty();
	}

	var part_size = 0; // declared here because it is used also after each()
	var hour_size = $('#hours a:first').outerWidth();
	var min_size = Math.floor(hour_size / 5);
	var time1 = g_begin_time.substr(14, 2) * 60 + g_begin_time.substr(17, 2) * 1;
	var time2 = g_end_time.substr(14, 2) * 60 + g_end_time.substr(17, 2) * 1;
	var time_bar_offset = $('#hours a:first').offset().left;
	var time_bar_length = 0;

	$('#hours a').each(function(){
		var hour = current_date + ' ' + $(this).text();

		if (hour < g_begin_time.substr(0, 13) || hour > g_end_time.substr(0, 13))
			return true;
		else if (hour == g_begin_time.substr(0, 13) && hour == g_end_time.substr(0, 13))
		{
			time_bar_offset = $(this).offset().left + Math.floor((time1 / 3600) * hour_size);
			part_size = Math.floor(((time2 - time1) / 3600) * hour_size);
			time_bar_length += part_size;
			$('#time_bar').append('<div class="searched" style="width: ' + part_size + 'px;"></div>');
			return false;
		}
		else if (hour == g_begin_time.substr(0, 13))
		{
			var part_shift = Math.floor((time1 / 3600) * hour_size);
			time_bar_offset = $(this).offset().left + part_shift;
			part_size = hour_size - part_shift;
			time_bar_length += part_size;
			$('#time_bar').append('<div class="searched" style="width: ' + part_size + 'px;"></div>');
			return true;
		}
		else if (hour == g_end_time.substr(0, 13))
		{
			part_size = Math.floor((time2 / 3600) * hour_size);
			time_bar_length += part_size;
			$('#time_bar').append('<div class="searched" style="width: ' + part_size + 'px;"></span>');
			return false;
		}
		else
		{
			time_bar_length += hour_size;
			$('#time_bar').append('<div class="'
				+ (($('#hour_' + $(this).text()).hasClass('in_db'))? 'searched' : 'skipped')
				+ '" style="width: ' + hour_size + 'px;"></span>');
			return true;
		}
	});

	if (time_bar_length < min_size)
	{
		$('#time_bar div:last').attr('style', 'width: ' + (min_size - time_bar_length + part_size) + 'px;');
		time_bar_length = min_size;
	}

	$('#time_bar').css('left', time_bar_offset + 'px');
	$('#time_bar').css('width', time_bar_length + 'px');
	$('#time_bar').show();

	if (!$('#time_frame').length)
		$('body').append('<div id="time_frame" style="position: absolute; top: '
			+ ($('#hours a:first').offset().top - 22) + 'px; display: none;"></div>');

	$('#time_frame').html('<a href="#" id="prev" title="Step back"><img src="/logserver/images/icons/arrow-left.png" alt="&laquo;" title="Step back" /></a> '
		+ '<span>' + ((g_begin_time.substr(0, 10) == g_end_time.substr(0, 10))?
			(g_begin_time.substr(11, 8) + ' &ndash; ' + g_end_time.substr(11, 8))
			: (g_begin_time + ' &ndash; ' + g_end_time)) + '</span>'
		+ ' <a href="#" id="next" title="Step forward"><img src="/logserver/images/icons/arrow-right.png" alt="&raquo;" title="Step forward" /></a>');

	var time_frame_offset = (time_bar_offset - Math.floor($('#time_frame').width() / 2)
		+ Math.floor($('#time_bar').outerWidth() / 2));

	if (time_frame_offset + $('#time_frame').outerWidth() > $('#days').outerWidth())
		time_frame_offset = $('#days').outerWidth() - $('#time_frame').outerWidth()
			+ $('#days').offset().left;

	$('#time_frame').css('left', time_frame_offset + 'px');
	$('#time_frame').css('width',
		(($('#hours a:last').offset().left + $('#hours a:last').outerWidth()) > 1105)? 'auto' : '250px');
	$('#time_frame').show();

	$(window).bind('resize', function(){
		remove_timeframe();
		render_timeframe();
	});
}

function popup_import(element)
{
	popup('#import_popup',
		'<div id="import_popup" style="position: absolute; left: '
		+ (element.offset().left) + 'px; top: '
		+ (element.offset().top + element.outerHeight())
		+ 'px;">These Logs are archived.<br />'
		+ 'Import <a id="import_hour" href="#">hour</a>'
		+ ' | <a id="import_day" href="#">day</a>'
		+ ' | <a id="import_month" href="#">month</a></div>', function()
	{

		var sanity_confirm = function (data, path, type) {

			data = JSON.parse(data);
			data.space = ((data.space / 1024) / 1024);
			data.size = (((data.size / 1024) / 1024) * data.size_mod);

			if ((data.size + data.fail_zone) > data.space) {

				alert(
					"Aborting Import of " + 
					data.filename + 
					", not enough space left on device (" + 
					data.size.toFixed(2) +
					"MB estimated/" + 
					data.space.toFixed(2) + "MB free)"
				);

			} else  if (

				confirm(
					"The archived log(s) for " + 
					data.filename + 
					" will occupy roughly " + 
					data.size.toFixed(2) +
					"Mb once loaded into the database.\n You have " + 
					data.space.toFixed(2) + 
					"Mb left on the partition that your database recides on. \n\n Do you wish to continue?")
				) {

				if (type == 'hour') {
					$('#hour_' + $('#hour').val()).attr('class', 'in_archive importing');
				} else if (type == 'day' || type == 'month') {
					$('#hours a.in_archive:not(.importing)').attr('class', 'in_archive importing');
				}

				$('#last_status').append('<p></p>');
				path = path.replace('?sanity&', '?');

				$('#last_status p:last').load(path, function(){

					$('#last_status').scrollTo($('p:last'), {axis: 'y', margin: true, duration: 100});
					importList = $(this).children('.hidden').text().split("\n");
					importList.pop();
					if (!importTimer)
						importTimer = setInterval(checkImport, 10000);

				});

			}

		};

		$('#import_hour, #import_day, #import_month').click(function () {

			var self = $(this),
				path = "",
				type = "";

			if (self.attr('id') == 'import_hour') {
				path = '/logserver/comps/import?sanity&year=' + $('#month').val().substr(0, 4)
					+ '&month=' + $('#month').val().substr(5, 7) + '&day=' + $('#day').val()
					+ '&hour=' + $('#hour').val();
				type = 'hour';
			} else if (self.attr('id') == 'import_day') {
				path = '/logserver/comps/import?sanity&year=' + $('#month').val().substr(0, 4)
					+ '&month=' + $('#month').val().substr(5, 7) + '&day=' + $('#day').val();
				type = 'day';
			} else if (self.attr('id') == 'import_month') {
				path = '/logserver/comps/import?sanity&year=' + $('#month').val().substr(0, 4)
					+ '&month=' + $('#month').val().substr(5, 7);
				type = 'month';
			}

			if (path && type) {

				$('#last_status p:last').load(
					path, function (data) {
						sanity_confirm(data, path, type);
					}
				);

			}
			
			return false;
			
		});

	});
	return false;
}

function get_offset(table, minutes, seconds)
{
	var offset = 0;
	$.ajax({
		url: '/logserver/comps/inquire',
		data: {
			table: g_table,
			filter: g_filter,
			query: ($('#query').val() == 'Search') ? '' : $('#query').val(),
			offset_time: table.substr(0, 10).replace(/_/g, '-') + ' '
				+ table.substr(11, 2) + ':' + minutes	+ ':' + seconds
		},
		success: function(result){
			offset = result;
		},
		dataType: 'html',
		cache: false,
		async: false
	});
	return offset;
}

function check_timespec()
{
	if (!(/^[0-5]?[0-9]$/).test($('#ch_minutes').val())
		|| !(/^[0-5]?[0-9]$/).test($('#ch_seconds').val()))
	{
		alert('Invalid time: ' + $('.current_hour').text() + ':' + $('#ch_minutes').val()
			+ ':' + $('#ch_seconds').val());
		return false;
	}
	if ($('#ch_minutes').val().length == 1)
		$('#ch_minutes').val('0' + $('#ch_minutes').val());
	if ($('#ch_seconds').val().length == 1)
		$('#ch_seconds').val('0' + $('#ch_seconds').val());
	return true;
}

function highlight_hour(element)
{
	if (!element.length) {
		return false;
	}
	$(element).addClass('current_hour');
	if (g_begin_offset != 0)
		return;

	$('body').append(
		'<div id="ch_popup" style="position: absolute; left: '
		+ (element.offset().left) + 'px; top: '
		+ (element.offset().top + element.outerHeight())
		+ 'px;"><a href="#" id="ch_prev" title="Search until the specified time"><img src="/logserver/images/icons/arrow-left.png" alt=""></a>'
		+ ' <form id="ch_form" action="#"><input type="text" id="ch_minutes" name="ch_minutes" maxlength="2" value="00"/>m'
		+ ' <input type="text" id="ch_seconds" name="ch_seconds" maxlength="2" value="00" />s</form>'
		+ ' <a href="#" id="ch_next" title="Search from the specified time"><img src="/logserver/images/icons/arrow-right.png" alt=""></a></div>');
	var offset = $('#ch_popup').offset().left;
	if (offset + $('#ch_popup').outerWidth() > $('#days').outerWidth())
		offset = $('#days').outerWidth() - $('#ch_popup').outerWidth()
			+ $('#days').offset().left;
	$('#ch_popup').css('left', offset - 7 + 'px');
	$('#ch_minutes, #ch_seconds').focus(function(){
		if ($(this).val() == '00')
			$(this).val('');
	});
	$('#ch_minutes, #ch_seconds').blur(function(){
		if ($(this).val() == '')
			$(this).val('00');
	});
	$('#ch_prev').click(function(){
		if (check_timespec())
		{
			g_begin_table = g_table;
			g_begin_offset = get_offset(g_table, $('#ch_minutes').val(), $('#ch_seconds').val());
			g_begin_time = g_begin_table.substr(0, 10).replace(/_/g, '-')
				+ ' ' + g_begin_table.substr(11, 2) + ':' + $('#ch_minutes').val()
				+ ':' + $('#ch_seconds').val();
			search_prev();
		}
		return false;
	});
	$('#ch_next').click(function(){
		if (check_timespec())
		{
			g_begin_table = g_table;
			$('#i_table').val(g_table);
			g_begin_offset = get_offset(g_table, $('#ch_minutes').val(), $('#ch_seconds').val());
			$('#i_offset').val(g_begin_offset);
			$('#i_limit').val(g_limit);
			g_direction = 'forward';
			$('#i_direction').val('forward');
			g_begin_prev = '';
			g_begin_next = '';
			g_begin_time = g_begin_table.substr(0, 10).replace(/_/g, '-')
				+ ' ' + g_begin_table.substr(11, 2) + ':' + $('#ch_minutes').val()
				+ ':' + $('#ch_seconds').val();
			g_disabled = true;
			new_results();
			do_search('normal');
		}
		return false;
	});
}

function unhighlight_hour(element)
{
	$(element).removeClass('current_hour');
	close_popups();
	$('#ch_prev').unbind('click');
	$('#ch_next').unbind('click');
	$('#ch_popup').remove();
}

$(document).ready(function(){
	g_disabled = true;

	$('#status').append('<div id="last_status"></div>');

	$('#import_status').load('/logserver/comps/import/', function(){
		importList = $(this).children('.hidden').text().split("\n");
		importList.pop();
		if (importList.length)
			importTimer = setInterval(checkImport, 10000);
	});

	$('#query').keypress(function(event){
		if (g_disabled) return false;
		if (event.which == 13)
		{
			$('#search_now').click();
			return false;
		}
	});
	$('#query').focus(function(){
		if ($(this).val() == 'Search')
			$(this).val('');
	});
	$('#query').blur(function(){
		if ($(this).val() == '')
			$(this).val('Search');
	});
	$('#search_now').click(function(){
		if (g_disabled) return false;
		cancelTail();
		if ($('#query').val() == 'Search')
			$('#i_query').val('');
		else
			$('#i_query').val($('#query').val());
		$('#i_filter').val(g_filter);
		if ($('#month').val() && $('#day').val() && $('#hour').val() && g_table)
			new_search();
		else
			tail_search();
	});

	setup_filter_picker();
	setup_filter_buttons();
	setup_query_builder();
	setup_filter_save();

	$('#search_notifier a').livequery('click', function(){
		if (g_search_in_progress)
		{
			g_stop_search = true;
			reset_search_notifier();
		}
		if (tailTimer)
			cancelTail();
		return false;
	});

	$('#ulSelectLimit').clickMenu({onClick: function(){
		var a = $(this).find('>a');
		if (a.length)
		{
			/*
			TODO: try to rework this to load more rows or remove unneeded,
			instead of reloadig the same data just with another limit
			*/
			$('#i_table').val(g_begin_table);
			g_limit = $(a).text();
			$('#i_limit').val(g_limit);
			/* no change of g_direction is made here */
			g_disabled = true;
			new_results();
			do_search('normal');
		}
	}});

	$('#tail').click(function(){
		if (g_disabled) return false;
		popup('#tail_picker',
			'<ul id="tail_picker" style="position: absolute; left: '
			+ ($(this).offset().left - 83) + 'px; top: '
			+ ($(this).offset().top + 23) + 'px;">'
			+ '<li><a href="#">30</a></li>'
			+ '<li><a href="#">45</a></li>'
			+ '<li><a href="#">60</a></li>'
			+ '<li><a href="#">90</a></li>'
			+ '<li><a href="#">120</a></li>'
			+ '<li><a href="#">300</a></li></ul>', function()
		{
			$('#tail_picker a').unbind('click');
			$('#tail_picker a').bind('click', function(){
				if (tailTimer)
					clearInterval(tailTimer);
				tailTimer = setInterval(tail_search, $(this).text() * 1000);
				$('#search_notifier').html('Updating every ' + $(this).text()
					+ ' seconds. <a href="#">Cancel</a>');
				$('#tail_picker').remove();

				if ($('#query').val() == 'Search')
					$('#i_query').val('');
				else
					$('#i_query').val($('#query').val());
				$('#i_filter').val(g_filter);

				tail_search();

				return false;
			});

			$('#tail_picker li a:first').focus();
		});
		return false;
	});

	$('#export_csv a').click(function(){
		if (g_disabled) return false;
		if ($('#results tbody tr').length)
		{
			$('#csv_filename').val(g_time_from.replace(/ /g, '-').replace(/:/g, '-')
				+ '_' + g_time_to.replace(/ /g, '-').replace(/:/g, '-'));
			$('#csv_text').empty();
			$('#results tbody tr').each(function(){
				$('#csv_text').append($(this).children().map(function(){
					return $(this).text();
				}).get().join('|') + "\n");
			});
			$('#exportcsvform').submit();
		}

		return false;
	});

	$('#prev').livequery('click', search_prev);
	$('#next').livequery('click', search_next);

	$('#months').load('/logserver/comps/timeline', function(){
		$('#months a:last').addClass('current_month');
		$('#month').val($('#months a:last').attr('id').substr(6, 7));
		$('#scroll_right').bind('click', function(){
			$('#months').scrollTo($('#months').scrollLeft() + Math.floor($('#months').width() / 4),
				{axis: 'x', duration: 100});
			return false;
		});
		$('#fast_scroll_right').bind('click', function(){
			$('#months').scrollTo($('#months a:last'),
				{axis: 'x', offset: -3*$('#months li:first').width(), duration: 100});
			return false;
		});
		$('#scroll_left').bind('click', function(){
			$('#months').scrollTo(($('#months').scrollLeft() >= Math.floor($('#months').width() / 4))
				? ($('#months').scrollLeft() - Math.floor($('#months').width() / 4)) : 0,
				{axis: 'x', duration: 100});
			return false;
		});
		$('#fast_scroll_left').bind('click', function(){
			$('#months').scrollTo($('#months a:first'),
				{axis: 'x', offset: -3*$('#months li:first').width(), duration: 100});
			return false;
		});

		$(window).bind('resize', function(){
			$('#months').scrollTo($('.current_month'),
				{axis: 'x', offset: -3*$('#months li:first').width(), duration: 100});
		});

		$('#days').load('/logserver/comps/timeline?month=' + $('#month').val(), function(){
			$('#days a:last').addClass('current_day');
			$('#day').val($('#days a:last').text());
			$('#hours').load('/logserver/comps/timeline?month=' + $('#month').val() + '&day=' + $('#day').val(), function(){
				highlight_hour($('#hours a:last'));
				$('#hour').val($('.current_hour').text());
				new_results();
				$('#results h1 span').eq(1).text(g_filter);
				$('#last_status').append('<p>Tail search started.</p>');
				$('#last_status').scrollTo($('#last_status p:last'), {axis: 'y', margin: true, duration: 100});
				$('#inquire').load('/logserver/comps/inquire?filter=' + g_filter.replace(/ /g, '+'));
			});
		});
	});

	$('#months > .end').livequery(function(){
		$('#months').scrollTo($('.current_month'),
			{axis: 'x', offset: -3*$('#months li:first').width(), duration: 100});
		$('#months a').bind('click', function(e){
			if (g_disabled) return false;
			cancelTail();
			$('#import_popup').remove();
			remove_timeframe();
			$('#months a').removeClass('current_month');
			$(this).addClass('current_month');
			$('#months').scrollTo($('.current_month'),
				{axis: 'x', offset: -3*$('#months li:first').width(), duration: 100});
			$('#month').val($(this).attr('id').substr(6, 10));
			$('#day').val('');
			$('#hour').val('');
			$('#search_notifier').html('Search from the end of database');
			$('#timelineform').ajaxSubmit({
				target: '#days',
				url: '/logserver/comps/timeline?month=' + $('#month').val()
			});
			$('#hours').empty();
			return false;
		});
	});
	$('#hours > .end').livequery(function() {
		if ($('#i_filter').val()) // do nothing on first load
			render_timeframe();
		$('#hours li a:first-child').unbind('click');
		$('#hours li a:first-child').bind('click', function(){
			if (g_disabled) return false;
			cancelTail();
			$('#import_popup').remove();
			$('#hour').val($(this).text()); // needed for archive hours too, used in popup_import()
			if ($(this).hasClass('in_db'))
			{
				unhighlight_hour($('#hours li a:first-child'));
				highlight_hour($(this));
				g_table = $('#month').val() + '_' + $('#day').val() + '_' + $('#hour').val();
				reset_search_notifier();
				new_search();
			}
			else if (!$(this).hasClass('importing') && $('#can_import').length == 1)
				popup_import($(this));
			return false;
		});
	});
	$('#days > .end').livequery(function(){
		$('#days a').unbind('click');
		$('#days a').bind('click', function(){
			if (g_disabled) return false;
			cancelTail();
			$('#import_popup').remove();
			remove_timeframe();
			$('#days a').removeClass('current_day');
			$(this).addClass('current_day');
			$('#day').val($(this).attr('id').substr(4,6));
			$('#hour').val('');
			$('#ch_popup').remove();
			$('#search_notifier').html('Search from the end of database');
			$('#timelineform').ajaxSubmit({
				target: '#hours',
				url: '/logserver/comps/timeline?month=' + $('#month').val() + '&day=' + $('#day').val()
			});
			return false;
		});
	});
	$('#inquire span.error').livequery(function(){
		alert($(this).text());
	});
	$('#inquire table').livequery(function(){
		remove_timeframe();

		if ($('#inquire table tr').length)
		{
			$('#column_picker li').each(function(i){
				if ($(this).hasClass('advoff'))
					$('#inquire table td:nth-child(' + (i + 1) + ')').hide();
			});

			/* TODO: handle order=asc/desc */
			if (g_direction == 'forward')
				$('#results table tbody').prepend($('#inquire table tr'));
			else
				$('#results table tbody').append($('#inquire table tr'));
		}

		/* remember prev & next tables of the search starting point */
		if (!g_inquiring)
		{
			g_inquiring = true;

			if (g_direction == 'forward')
			{
				g_begin_prev = $('#table_prev').val();
				g_begin_next = $('#table_next').val();
			}
			else
			{
				g_end_prev = $('#table_prev').val();
				g_end_next = $('#table_next').val();
			}
			/* DEBUG
			alert('search started' + '\n---\n'
				+ 'g_table = ' + g_table + '\n---\n'
				+ 'g_begin_table = ' + g_begin_table + '\n'
				+ 'g_begin_offset = ' + g_begin_offset + '\n'
				+ 'g_begin_prev = ' + g_begin_prev + '\n'
				+ 'g_begin_next = ' + g_begin_next + '\n---\n'
				+ 'g_end_table = ' + g_end_table + '\n'
				+ 'g_end_offset = ' + g_end_offset + '\n'
				+ 'g_end_prev = ' + g_end_prev + '\n'
				+ 'g_end_next = ' + g_end_next);
			*/
		}

		/*
		remember where the search was finished

		Note: this is done every cycle instead of at the end of data loading
		to work correctly when there are less than g_limit results and thus there
		are empty replies at the end of the search
		*/
		if ($('#msg_count').val())
		{
			var offset = parseInt($('#i_offset').val());
			var msg_count = parseInt($('#msg_count').val());

			if (g_direction == 'forward')
			{
				if ($('#i_offset').val() == '0' && $('#i_direction').val() == 'backwards')
				{
					/* move to the next table because we've reached offset -0 :-) */
					g_end_offset = 0;
					g_end_table = $('#table_next').val();
					g_end_prev = $('#i_table').val();
					g_end_next = $('#table_next2').val();
				}
				else
				{
					g_end_table = $('#i_table').val();

					if (g_begin_table == $('#i_table').val())
						g_end_offset = offset + msg_count;
					else
						g_end_offset = msg_count;

					g_end_prev = $('#table_prev').val();
					g_end_next = $('#table_next').val();
				}
				g_end_time = ($('#results tbody tr').length)?
					$('#results tbody tr:first td:nth-child(3)').text()
					: ((g_end_next != '')?
						($('#i_table').val().substr(0, 10).replace(/_/g, '-')
							+ ' ' + $('#i_table').val().substr(11, 2) + ':59:59')
						: get_current_time());

				if (g_begin_time == '')
					g_begin_time = $('#i_table').val().substr(0, 10).replace(/_/g, '-')
						+ ' ' + $('#i_table').val().substr(11, 2) + ':00:00';
			}
			else
			{
				g_begin_table = $('#i_table').val();

				//alert("i_table = " + $('#i_table').val() + "\noffset = " + offset + "\ng_begin_offset = " + g_begin_offset);
				if (g_end_table == $('#i_table').val())
				{
					if (offset < 0)
						g_begin_offset = offset - msg_count;
					else
						g_begin_offset = offset;
				}
				else
					g_begin_offset = -msg_count;

				g_begin_prev = $('#table_prev').val();
				g_begin_next = $('#table_next').val();
				g_begin_time = ($('#results tbody tr').length)?
					$('#results tbody tr:last td:nth-child(3)').text()
					: ($('#i_table').val().substr(0, 10).replace(/_/g, '-')
						+ ' ' + $('#i_table').val().substr(11, 2) + ':00:00');

				if (g_table == '')
					g_end_time = get_current_time();
			}

			/*
			   workaround to display something meaningful in timeframe
			   when there are no messages in the database at all
			*/
			if (g_begin_time == ' :00:00')
				g_begin_time = '. . .';

			/* DEBUG
			alert('g_begin_time = ' + g_begin_time + '\n' + 'g_end_time = ' + g_end_time);
			*/
			render_timeframe(); // resize timeframe to show search progress
		}

		/* check if all results are loaded and if there may be more - request more */
		if (!g_stop_search && $('#results tbody tr').length < g_limit
			&& (g_direction == 'forward') && $('#table_next').val())
		{
			$('#i_table').val($('#table_next').val());
			$('#i_direction').val('forward');
			$('#i_limit').val(g_limit - $('#results tbody tr').length);
			$('#i_offset').val(0);
			g_disabled = true;
			/* DEBUG
			alert('Found ' + $('#msg_count').val() + ' messages.\n'
				+ 'Need ' + (g_limit - $('#results tbody tr').length) + ' more.');
			*/
			$('#inquireform').ajaxSubmit({target: '#inquire'});
			return;
		}
		else if (!g_stop_search && $('#results tbody tr').length < g_limit
			&& (g_direction == 'backwards') && $('#table_prev').val())
		{
			$('#i_table').val($('#table_prev').val());
			$('#i_direction').val('backwards');
			$('#i_limit').val(g_limit - $('#results tbody tr').length);
			$('#i_offset').val(0);
			g_disabled = true;
			/* DEBUG
			alert('Found ' + $('#msg_count').val() + ' messages.\n'
				+ 'Need ' + (g_limit - $('#results tbody tr').length) + ' more.');
			*/
			$('#inquireform').ajaxSubmit({target: '#inquire'});
			return;
		}
		/* else limit is reached or no more results are available */
		else if ($('#results tbody tr').length)
		{
			g_inquiring = false;

			/* these are times of first and last message found; they are used for csv export */
			g_time_from = $('#results tbody tr:last td:nth-child(3)').text();
			g_time_to = $('#results tbody tr:first td:nth-child(3)').text();

			/* set new starting table after doing a tail search */
			if (g_table == '')
				g_table = $('#i_table').val();

			if (g_begin_table == g_end_table && g_end_offset == g_limit && g_begin_offset == -g_limit)
				g_begin_offset = 0;

			/* DEBUG
			alert('search finished' + '\n---\n'
				+ 'g_table = ' + g_table + '\n---\n'
				+ 'g_begin_table = ' + g_begin_table + '\n'
				+ 'g_begin_offset = ' + g_begin_offset + '\n'
				+ 'g_begin_prev = ' + g_begin_prev + '\n'
				+ 'g_begin_next = ' + g_begin_next + '\n---\n'
				+ 'g_end_table = ' + g_end_table + '\n'
				+ 'g_end_offset = ' + g_end_offset + '\n'
				+ 'g_end_prev = ' + g_end_prev + '\n'
				+ 'g_end_next = ' + g_end_next);
			*/

			/* update the timeline to match the first hour of results */
			var start_time = $('#results tbody tr:last td:eq(2)').text();
			$('#months').load('/logserver/comps/timeline', function(){
				$('#month').val(start_time.substr(0, 7).replace(/-/, '_'));
				$('#month_' + $('#month').val()).addClass('current_month');
				$('#days').load('/logserver/comps/timeline?month=' + $('#month').val(), function(){
					$('#day').val(start_time.substr(8, 2));
					$('#day_' + $('#day').val()).addClass('current_day');
					$('#hours').load('/logserver/comps/timeline?month=' + $('#month').val() + '&day=' + $('#day').val(), function(){
						$('#hour').val(start_time.substr(11, 2));
						unhighlight_hour($('#hours li a:first-child'));
						if (g_table.substr(0, 7) == $('#month').val() && g_table.substr(8, 2) == $('#day').val())
							highlight_hour($('#hour_' + g_table.substr(11, 2)));
						// render_timeframe() is called when hourline is loaded
						g_disabled = false;
						reset_search_notifier();
					});
				});
			});
		}
		else /* no results found */
		{
			g_disabled = false;
			reset_search_notifier();
		}

		$('#last_status').append('<p>Search ' + (g_stop_search ? 'stopped' : 'finished') + '.</p>');
		$('#last_status').scrollTo($('#last_status p:last'), {axis: 'y', margin: true, duration: 100});
		g_search_in_progress = false;
		g_stop_search = false;

		if ($('#results tbody tr').length)
			$('#results table').tablesorter({sortList: [[2, 1]]});

		$('#table_buttons').show();
	});
});
