var rxFilterName = /^([-_ .,0-9A-Za-z]+)$/;

var saveFilterSubmitOptions = {
	url: '/logserver/comps/filters',
	target: '#filter_picker',
	success: function(responseText, statusText){
		if ($('#filter_picker span:first').hasClass('hidden'))
		{
			$('#filter_picker span:first').remove();
			$('#last_status').append("<p>Could not add filter '" + $('#newfilter').val() + "'.</p>");
			alert("Could not add filter '" + $('#newfilter').val()
				+ "'.\nPossible reasons:\n"
				+ "* there is a global filter with the same name and you are not admin,\n"
				+ "* another user has a private filter with the same name,\n"
				+ "* you are trying to replace parent filter.");
		}
		else
		{
			g_filter = $('#newfilter').val();
			$('#last_status').append("<p>Filter '" + $('#newfilter').val() + "' has been added.</p>");
			$('#newfilter').val('');
			$('#query').val('Search');
			update_hierarchy();
		}
		$('#last_status').scrollTo($('p:last'), {axis: 'y', margin: true, duration: 500});
	}
};

function setup_filter_buttons(){
	$('#edit').livequery('click', function(){
		if (g_disabled) return false;
		if (g_filter != '')
		{
			$('#filter_info').load('/logserver/comps/filters?filter='
					+ g_filter.replace(/ /g, '+') + '&action=get_info', function()
			{
				if ($(this).children().eq(0).text() == '')
					return;

				$('#newfilter').val(g_filter);
				g_filter = $(this).children().eq(0).text();
				$('#query').val($(this).children().eq(1).text());

				// special handling due to customization of the checkbox
				if ($(this).children().eq(2).text() == 'true')
				{
					$('#global').attr('checked', 'checked');
					$('#global').prev().css('background-position', '0 -' + checkboxHeight*2 + 'px');
				}
				else
				{
					$('#global').removeAttr('checked');
					$('#global').prev().css('background-position', '0 0');
				}

				update_hierarchy();
			});
		}

		return false;
	});

	$('#delete').livequery('click', function(){
		if (g_disabled) return false;

		var filter = g_filter;

		if (confirm("The filter '" + filter + "' will be destroyed.\nDo you want to continue?"))
		{
			$('#filter_picker').load('/logserver/comps/filters?action=check_children&filter='
				+ filter.replace(/ /g, '+'),
				// spaces are replaced with + to form a valid URL
				function()
			{
				if ($('#filter_picker span:first').hasClass('hidden'))
				{
					$('#filter_picker span:first').remove();
					if (!confirm("The are filters that are based on filter '" + filter
						+ "'.\nDestroying filter '" + filter
						+ "' will make them non-functional.\nDo you want to continue?"))
					{
						return;
					}
				}

				$('#filter_picker').load('/logserver/comps/filters?action=remove&filter='
					+ filter.replace(/ /g, '+'),
					// spaces are replaced with + to form a valid URL
					function()
				{
					if ($('#filter_picker span:first').hasClass('hidden'))
					{
						$('#filter_picker span:first').remove();
						$('#last_status').append("<p>Could not remove filter '" + $('#newfilter').val() + "'.</p>");
						// this should never happen, but better report error in case it does
					}
					else
					{
						if ($('#default_filter').length)
							g_filter = $('#default_filter').text();
						else
							g_filter = $('#filter_picker li a:first').text();

						update_hierarchy();

						$('#last_status').append("<p>Filter '" + filter + "' has been removed.</p>");
					}
					$('#last_status').scrollTo($('p:last'), {axis: 'y', margin: true, duration: 500});
				});
			});
		}

		$('#filter_picker').addClass('hidden');
		$('#filter_picker').removeAttr('style');
		return false;
	});

	$('#permissions').livequery('click', function(){
		if (g_disabled) return false;
		if ($('#manage_filters_popup').length)
			$('#manage_filters_popup').remove();

		var filter = g_filter;
		var filtertype = ($('#hierarchy').children('span.global').length)? 'global' : 'own';

		close_popups();
		$('body').append('<div id="manage_filters_popup"></div>');
		$('#manage_filters_popup').load('/logserver/view/logs/filterspopup.inc.php', function(){
			$('#dim').css('height', $(document).height() + 'px');
			$('#selectfilterform').submit(function(){
				return false;
			});

			$('#close_manage_filters_popup').click(function(){
				$('#manage_filters_popup').remove();

				$('#filter_picker').load('/logserver/comps/filters', function() {
					// this is wrong because 'contains' returns elements with partial matches too!
					// if (!$('#filter_picker li a:contains("' + g_filter + '")').length)
					if (!$('#filter_picker li a').filter(function(){
						if ($(this).text() == g_filter)
							return true;
						else
							return false;
						}).length)
					{
						if ($('#default_filter').length)
							g_filter = $('#default_filter').text();
						else
							g_filter = $('#filter_picker li a:first').text();

						update_hierarchy();
					}
				});

				return false;
			});

			$('#globalfilters').load('/logserver/comps/filters?type=global', function(){
				$('#globalfilters option').each(function(){
					if ($(this).text() == filter)
						$(this).attr('selected', 'selected');
				});
			});
			$('#ownfilters').load('/logserver/comps/filters?type=own', function(){
				$('#ownfilters option').each(function(){
					if ($(this).text() == filter)
						$(this).attr('selected', 'selected');
				});
			});

			$('#globalfilters').focus(function(){
				$('#ownfilters').val('');
			});
			$('#ownfilters').focus(function(){
				$('#globalfilters').val('');
			});
			$('#globalfilters, #ownfilters').expire();
			$('#globalfilters, #ownfilters').livequery('change', function(){
				filter = $(this).val();
				filtertype = ($(this).attr('id') == 'globalfilters')? 'global' : 'own';
				$('#filterforms').load('/logserver/view/logs/filterusersform.inc.php?filter='
					+ filter.replace(/ /g, '+') + '&filtertype=' + filtertype);
			});

			$('#make_global').click(function(){
				if (!$('#ownfilters').val())
					return false;

				if (confirm("Are you sure you want to make filter '" + filter
					+ "' global?\nAll its private parents (if any) will be made global as well."))
				{
					$('#globalfilters').load('/logserver/comps/filters?type=global&action=make_global&filter=' + filter.replace(/ /g, '+'), function(){
						$('#ownfilters').load('/logserver/comps/filters?type=own');
						$('#globalfilters option').each(function(){
							if ($(this).text() == filter)
							{
								$(this).attr('selected', 'selected');
								filtertype = 'global';
							}
						});
						$('#filterforms').load('/logserver/view/logs/filterusersform.inc.php?filter='
							+ filter.replace(/ /g, '+') + '&filtertype=' + filtertype);
					});
				}
			});
			$('#make_own').click(function(){
				if (!$('#globalfilters').val())
					return false;

				if (filter == 'All')
				{
					alert("You cannot make filter 'All' your own.");
					return false;
				}
				if (confirm("Are you sure you want to make filter '" + filter
					+ "' private?\nAll its global children (if any) will be made private as well."))
				{
					$('#ownfilters').load('/logserver/comps/filters?type=own&action=make_own&filter=' + filter.replace(/ /g, '+'), function(){
						$('#globalfilters').load('/logserver/comps/filters?type=global');
						$('#ownfilters option').each(function(){
							if ($(this).text() == filter)
							{
								$(this).attr('selected', 'selected');
								filtertype = 'own';
							}
						});
						$('#filterforms').load('/logserver/view/logs/filterusersform.inc.php?filter='
							+ filter.replace(/ /g, '+') + '&filtertype=' + filtertype);
					});
				}
			});

			$('#filterforms').load('/logserver/view/logs/filterusersform.inc.php?filter='
				+ filter.replace(/ /g, '+') + '&filtertype=' + filtertype);

			$('#filterforms > .end').expire();
			$('#filterforms > .end').livequery(function(){
				if ($('#filterusersform').length)
				{
					$('#filterusersform').submit(function(){
						return false;
					});
					$('#fu_type').val('allowed');
					$('#fu_view').val('users');
					$('#filterusersform').ajaxSubmit({target: '#allowedusers', success: function(){
						$('#fu_type').val('allowed');
						$('#fu_view').val('groups');
						$('#filterusersform').ajaxSubmit({target: '#allowedgroups', success: function(){
							$('#fu_type').val('disallowed');
							$('#fu_view').val('users');
							$('#filterusersform').ajaxSubmit({target: '#disallowedusers', success: function(){
								$('#fu_type').val('disallowed');
								$('#fu_view').val('groups');
								$('#filterusersform').ajaxSubmit({target: '#disallowedgroups'});
							}});
						}});
					}});

					$('#fu_add').click(function(){
						if ($('#disallowedusers').val())
						{
							$('#disallowedusers').attr('name', 'users[]');
							$('#fu_type').val('allowed');
							$('#fu_view').val('users');
							$('#fu_action').val('add');
							$('#filterusersform').ajaxSubmit({target: '#allowedusers', success: function(){
								$('#disallowedusers option:selected').remove();
								$('#disallowedusers').removeAttr('name');
							}});
						}
						else if ($('#disallowedgroups').val())
						{
							$('#disallowedgroups').attr('name', 'groups[]');
							$('#fu_type').val('allowed');
							$('#fu_view').val('groups');
							$('#fu_action').val('add');
							$('#filterusersform').ajaxSubmit({target: '#allowedgroups', success: function(){
								$('#disallowedgroups option:selected').remove();
								$('#disallowedgroups').removeAttr('name');
								$('#fu_type').val('disallowed');
								$('#fu_view').val('users');
								$('#fu_action').val('');
								$('#filterusersform').ajaxSubmit({target: '#disallowedusers'});
							}});
						}
						return false;
					});

					$('#fu_remove').click(function(){
						if ($('#allowedusers').val())
						{
							$('#allowedusers').attr('name', 'users[]');
							$('#fu_type').val('disallowed');
							$('#fu_view').val('users');
							$('#fu_action').val('remove');
							$('#filterusersform').ajaxSubmit({target: '#disallowedusers', success: function(){
								$('#allowedusers option:selected').remove();
								$('#allowedusers').removeAttr('name');
							}});
						}
						else if ($('#allowedgroups').val())
						{
							$('#allowedgroups').attr('name', 'groups[]');
							$('#fu_type').val('disallowed');
							$('#fu_view').val('groups');
							$('#fu_action').val('remove');
							$('#filterusersform').ajaxSubmit({target: '#disallowedgroups', success: function(){
								$('#allowedgroups option:selected').remove();
								$('#allowedgroups').removeAttr('name');
								$('#fu_type').val('disallowed');
								$('#fu_view').val('users');
								$('#fu_action').val('');
								$('#filterusersform').ajaxSubmit({target: '#disallowedusers'});
							}});
						}
						return false;
					});

					$('#allowedusers').expire();
					$('#allowedgroups').expire();
					$('#disallowedusers').expire();
					$('#disallowedgroups').expire();
					$('#allowedusers').livequery('mousedown', function(){
						$('#allowedgroups').val('');
						return false;
					});
					$('#allowedgroups').livequery('mousedown', function(){
						$('#allowedusers').val('');
						return false;
					});
					$('#disallowedusers').livequery('mousedown', function(){
						$('#disallowedgroups').val('');
						return false;
					});
					$('#disallowedgroups').livequery('mousedown', function(){
						$('#disallowedusers').val('');
						return false;
					});
				}
			});
		});
		return false;
	});
}

function setup_filter_save()
{
	$('#newfilter').keypress(function(event){
		if (g_disabled) return false;
		if (event.which == 13)
		{
			$('#save').click();
			return false;
		}
	});
	$('#save').click(function(){
		if (g_disabled) return false;

		var fail = false;

		if (($('#newfilter').val() != 'Save this search as') && ($('#query').val() != 'Search')
			&& ($('#query').val() != ''))
		{
			$('#newfilter').val(jQuery.trim($('#newfilter').val()));
			if ($('#newfilter').val() == 'All')
			{
				alert("Filter 'All' is not editable.");
				return false;
			}
			if (!jQuery.trim($('#newfilter').val()).length >= 4)
			{
				alert('Filter name is invalid. Must be 3 or more characters');
				return false;
			}
			$('#filter_picker li a').each(function(i){
				if ($(this).text() == $('#newfilter').val())
					if (!confirm("The filter with name '" + $(this).text() + "' already exists.\nDo you want to overwrite it?"))
						fail = true;
			});
			if (!fail)
				$('#searchform').ajaxSubmit(saveFilterSubmitOptions);
		}
	});
	$('#newfilter').focus(function(){
		if ($(this).val() == 'Save this search as')
			$(this).val('');
	});
	$('#newfilter').blur(function(){
		if ($(this).val() == '')
			$(this).val('Save this search as');
	});
}
