var rxEventID = /^[0-9][0-9 ]*$/;

function build_query()
{
	$('#query').val('');

	if ($('#qb_severity').val())
		$('#query').val($('#query').val() + ' sev=(' + $('#qb_severity').val().join(' ') + ')');

	if ($('#qb_facility').val())
		$('#query').val($('#query').val() + ' fac=(' + $('#qb_facility').val().join(' ') + ')');

	/*
	if ($('#qb_rtime').val())
		$('#query').val($('#query').val() + " rtime=\"" + $('#qb_rtime').val() + "\"");
	if ($('#qb_rtime_not').val())
		$('#query').val($('#query').val() + " -rtime=\"" + $('#qb_rtime_not').val() + "\"");

	if ($('#qb_mtime').val())
		$('#query').val($('#query').val() + " mtime=\"" + $('#qb_mtime').val() + "\"");
	if ($('#qb_mtime_not').val())
		$('#query').val($('#query').val() + " -mtime=\"" + $('#qb_mtime_not').val() + "\"");
	*/

	if (rxEventID.test($('#qb_event_id').val()))
		$('#query').val($('#query').val() + ' event=(' + $('#qb_event_id').val() + ')');
	if (rxEventID.test($('#qb_event_id_not').val()))
		$('#query').val($('#query').val() + ' -event=(' + $('#qb_event_id_not').val() + ')');

	if ($('#qb_source_ip').val())
		$('#query').val($('#query').val() + ' ip=(' + $('#qb_source_ip').val() + ')');
	if ($('#qb_source_ip_not').val())
		$('#query').val($('#query').val() + ' -ip=(' + $('#qb_source_ip_not').val() + ')');

	if ($('#qb_ident').val())
		$('#query').val($('#query').val() + ' ident=(' + $('#qb_ident').val() + ')');
	if ($('#qb_ident_not').val())
		$('#query').val($('#query').val() + ' -ident=(' + $('#qb_ident_not').val() + ')');

	if ($('#qb_host').val())
		$('#query').val($('#query').val() + ' host=(' + $('#qb_host').val() + ')');
	if ($('#qb_host_not').val())
		$('#query').val($('#query').val() + ' -host=(' + $('#qb_host_not').val() + ')' );

	if ($('#qb_pid').val())
		$('#query').val($('#query').val() + ' pid=(' + $('#qb_pid').val() + ')');
	if ($('#qb_pid_not').val())
		$('#query').val($('#query').val() + ' -pid=(' + $('#qb_pid_not').val() + ')');

	if ($('#qb_msg').val())
		$('#query').val($('#query').val() + ' msg=(' + $('#qb_msg').val() + ')');
	if ($('#qb_msg_not').val())
		$('#query').val($('#query').val() + ' -msg=(' + $('#qb_msg_not').val() + ')');

	if ($('#qb_fts').val())
		$('#query').val($('#query').val() + ' (' + $('#qb_fts').val() + ')');
	if ($('#qb_fts_not').val())
		$('#query').val($('#query').val() + ' -(' + $('#qb_fts_not').val() + ')');
}

function setup_query_builder()
{
	var qb_toggle = false;
	$('#qb_toggle').toggle(function(){
		if (g_disabled) return false;
		if (!qb_toggle)
		{
			//$('#qb_toggle img').attr('src', '/logserver/images/icons/query-builder-expanded.png');
			if ($('#query').val() == 'Search')
				$('#query').val('');

			$('#qb_tree').load('/logserver/comps/inquire?html=1&query=' + escape($('#query').val()), function(){
				// the .unset is used to correctly handle multiple [-]{sev,fac} in one query
				$('#qb_severity option').addClass('unset');
				$('#qb_facility option').addClass('unset');

				$(this).children().each(function(){
					var condition = $(this).children().eq(0).text();
					var column = $(this).children().eq(1).text();
					var operator = $(this).children().eq(2).text();
					var args = $(this).children().eq(3).children();
					var id = '#qb_' + column;

					if (condition != '1' && column != 'facility' && column != 'severity')
						id = id + '_not';

					if (!$(id).length)
					{
						alert('Unknown field name: ' + column);
						return true;
					}

					if (operator != 'equals')
					{
						alert('Query builder does not support operators other than =');
						return true;
					}

					$(args).each(function(){
						var arg = $(this).text();

						if (column == 'facility' || column == 'severity')
						{
							if ($(id).children().filter(function(){
								if ($(this).text() == arg)
									return true;
								else
									return false;
							}).length)
							{
								if (condition == 1)
									$(id).children('.unset').each(function(){
										if ($(this).text() == arg)
										{
											$(this).attr('selected', 'selected');
											$(this).removeClass('unset');
										}
									});
								else
									$(id).children('.unset').each(function(){
										if ($(this).text() == arg)
										{
											$(this).removeAttr('selected');
											$(this).removeClass('unset');
										}
									});
							}
							else
								alert('Unknown ' + column + ': ' + arg);
						}
						else
						{
							var special_chars = new RegExp('[() ]');

							if (special_chars.test(arg))
								arg = '"' + arg + '"';

							$(id).val($(id).val() + arg + ' ');
						}

						return true;
					});

					return true;
				});

				if ($('#qb_severity option:not(.unset):not(:selected)').length
					&& !$('#qb_severity option:not(.unset):selected').length)
				{
					$('#qb_severity option.unset').attr('selected', 'selected');
				}

				if ($('#qb_facility option:not(.unset):not(:selected)').length
					&& !$('#qb_facility option:not(.unset):selected').length)
				{
					$('#qb_facility option.unset').attr('selected', 'selected');
				}

				$('#qb_severity option').removeClass('unset');
				$('#qb_facility option').removeClass('unset');

				remove_timeframe();
				$('#query_builder').slideDown(500, function(){
					$('#query').attr('readonly', 'readonly');
					$('#query').attr('style', 'color: #A9A9A9;');
					render_timeframe();
					qb_toggle = true;
				});
			});
		}
		return false;
	}, function() {
		if (qb_toggle)
		{
			//$('#qb_toggle img').attr('src', '/logserver/images/icons/query-builder-closed.png');
			remove_timeframe();
			$('#query_builder').slideUp(500, function(){
				$('#query').removeAttr('readonly');
				$('#query').removeAttr('style');
				if (!$('#query').val())
					$('#query').val('Search');
				render_timeframe();
				qb_toggle = false;
				$('#query_builder select, #query_builder input').each(function(){
					$(this).val('');
				});
			});
		}
		return false;
	});

	$('#query_builder').keypress(function(event){
		if (g_disabled) return false;
		if (event.which == 13)
		{
			build_query();
			$('#search_now').click();
			return false;
		}
	});

	$('#query_builder select, #query_builder input').blur(function(){
		build_query();
	});
}
