function auto_report_creation_finished()
{
	if (!$('#addautoreportform table').length)
		return true;
	else if (confirm("You didn't finish report creation. Discard changes?"))
	{
		$('#addautoreportform').hide();
		$('#addautoreportform table').remove();
		$('#addnewautoreport').parent().show();
		return true;
	}
	else
		return false;
}

function auto_report_editing_finished()
{
	if (!$('#editautoreportform').length)
		return true;
	else if (confirm("You didn't finish report editing. Discard changes?"))
	{
		$('#editrow').remove();
		$('tr:hidden').show();
		return true;
	}
	else
		return false;
}

function run_auto_reports()
{
	var rxReportName = /^([-_ ,.()0-9A-Za-z]+)$/;
	var rxPath = /^([-+_.@!~()/:0-9A-Za-z]+)$/;
	var rxEmail = /^(([\w]+)((\.|-|_)[\w]+)*@([\w]+)((\.|-)[\w]+)*(\.[a-zA-Z]{2,6}))((,(( )*)(([\w]+)((\.|-|_)[\w]+)*@([\w]+)((\.|-)[\w]+)*(\.[a-zA-Z]{2,6})))*)$/;

	function error(message)
	{
		alert(message);
		return false;
	}

	$('#addautoreportform').hide();

	$('#addnewautoreport').click(function(){
		if (!auto_report_creation_finished() || !auto_report_editing_finished())
			return false;

		$(this).parent().slideUp(50);

		$('#addautoreportform').ajaxForm({
			target: '#list',
			beforeSubmit: function(formData, jqForm, options){
				// this doesn't work!!!
				// $('#reportname').val(jQuery.trim($('#reportname').val()));
				// so this ugly workaround is used
				for (var i=0; i < formData.length; i++) {
					if (formData[i].name == 'reportname')
						formData[i].value = jQuery.trim(formData[i].value);
					if (formData[i].name == 'description')
						formData[i].value = jQuery.trim(formData[i].value);
					if (formData[i].name == 'recipients')
						formData[i].value = jQuery.trim(formData[i].value);
				}
				// the following still works as usual
				if ($('#reportname').val() == "")
					return error('Please enter the report name');

				if ($('#recipients').val() == "")
					return error('Please enter the recipients');

				if (!rxReportName.test($('#reportname').val()))
					return error('Report name is invalid.');

				if ($('#recipient_type').val() == '0' && !rxEmail.test($('#recipients').val()))
					return error('Email is invalid.');
				if ($('#recipient_type').val() == '1' && (!rxPath.test($('#recipients').val())))
					return error('File path is invalid.');
			},
			success: function(){
				$('#addautoreportform').slideUp(500, function(){
					$('#addautoreportform table').remove();
					$('#addnewautoreport').parent().slideDown(50);
				});
			}
		});

		$('#addautoreportform').load('/logserver/view/reports/autoreportform.inc.php', function(){
			$(this).slideDown(500);
			$('#reportname').focus();
			$('#action').val('create');

			$('#filter_container').load('/logserver/comps/filters?simple=1');

			$('#cancel').click(function(){
				$('#addautoreportform').slideUp(500, function(){
					$('#addautoreportform table').remove();
					$('#addnewautoreport').parent().slideDown(50);
				});
				return false;
			});
		});
	});

	$('#list').load('/logserver/comps/reports');

	$('#list > .end').livequery(function(){
		$('#list table').tablesorter({sortList: [[0, 0]],
			headers: {7: {sorter: false}, 8: {sorter: false}, 9: {sorter: false}}});

		$('.edit a').click(function(){
			if (auto_report_creation_finished() && auto_report_editing_finished())
			{
				var original = $(this).parent().parent();

				original.hide();
				original.after('<tr id="editrow"><td colspan="9"><form id="editautoreportform" action="/logserver/comps/reports" method="post"></form></td></tr>');
				$('#editautoreportform').hide();
				$('#editautoreportform').load('/logserver/view/reports/autoreportform.inc.php', function(){
					$('#editautoreportform').ajaxForm({
						target: '#list',
						beforeSubmit: function(formData, jqForm, options){
							// this doesn't work!!!
							// $('#reportname').val(jQuery.trim($('#reportname').val()));
							// so this ugly workaround is used
							for (var i=0; i < formData.length; i++) {
								if (formData[i].name == 'reportname')
									formData[i].value = jQuery.trim(formData[i].value);
								if (formData[i].name == 'description')
									formData[i].value = jQuery.trim(formData[i].value);
								if (formData[i].name == 'recipients')
									formData[i].value = jQuery.trim(formData[i].value);
							}
							// the following still works as usual
							if ($('#reportname').val() == "")
								return error('Please enter the report name');

							if ($('#recipients').val() == "")
								return error('Please enter the recipients');

							if (!rxReportName.test($('#reportname').val()))
								return error('Report name is invalid.');

							if ($('#recipient_type').val() == '0' && !rxEmail.test($('#recipients').val()))
								return error('Email is invalid.');
							if ($('#recipient_type').val() == '1' && (!rxPath.test($('#recipients').val())))
								return error('File path is invalid.');
						}
					});

					$(this).slideDown(500);
					$('#reportname').focus();

					$('#action').val('save');
					$('#reportname').val(original.children().eq(5).text());
					$('#orig_reportname').val($('#reportname').val());
					$('#description').val(original.children().eq(6).text());

					$('#filter_container').load('/logserver/comps/filters?simple=1', function(){
						$('#filter option').each(function(){
							if ($(this).text() == original.children().eq(1).text())
							{
								$('#filter').val($(this).text());
								return true;
							}
						});
					});

					$('#recipient_type').val(original.children().eq(0).text());
					$('#recipients').val(original.children().eq(4).text());
					$('#interval_type').val(original.children().eq(3).children('.hidden').text());

					$('#cancel').click(function(){
						$('#editautoreportform').slideUp(500, function(){
							$('#editrow').remove();
							original.show();
						});
						return false;
					});
				});
			}

			return false;
		});

		$('#list > table td').dblclick(function(){
			$(this).parent().children('.edit').children('a').click();
			return false;
		});

		$('.remove a').click(function(){
			if (auto_report_creation_finished() && auto_report_editing_finished())
			{
				var reportname = $(this).parent().siblings().eq(5).text();

				//$('tr.msg').remove();
				if (confirm("Remove report '" + reportname + "'?"))
					$('#list').load('/logserver/comps/reports?action=delete&reportname=' + reportname.replace(/ /g, '+'), function(){
						//$('#...').prepend('<tr class="msg ok"><th colspan="2">Report has been deleted.</th></tr>');
					});
			}

			return false;
		});

		$('.send-now-small a').click(function(event){
			var reportname = $(this).parent().siblings().eq(5).text();
			$('tr.msg').remove();
			$('#list').load('/logserver/comps/reports?immediately=' + reportname.replace(/ /g, '+'), function(){
				if ($('span.error').length)
					alert("Could not send the report '" + reportname + "'");
				else if ($('span.error1').length)
					alert("Could not send the report '" + reportname + "'. Filter does not exist.");
				else
					alert("Report '" + reportname + "' has been sent.");
			});
			return false;
		});
	});
}
