function global_summary_report_creation_finished()
{
	if (!$('#addglobalsummaryreportform table').length)
		return true;
	else if (confirm("You didn't finish report creation. Discard changes?"))
	{
		$('#addglobalsummaryreportform').hide();
		$('#addglobalsummaryreportform table').remove();
		$('#addnewglobalsummaryreport').parent().show();
		return true;
	}
	else
		return false;
}

function global_summary_report_viewing_finished()
{
	if (!$('#viewglobalsummaryreportform').length)
		return true;
	else
	{
		$('#editrow').remove();
		$('tr:hidden').show();
		return true;
	}
}

function run_global_summary_reports()
{
	var rxReportName = /^([-_ ,.()0-9A-Za-z]+)$/;
	var rxPath = /^([-+_.@!~()/:0-9A-Za-z]+)$/;
	var rxEmail = /^(([\w]+)((\.|-|_)[\w]+)*@([\w]+)((\.|-)[\w]+)*(\.[a-zA-Z]{2,6}))((,(( )*)(([\w]+)((\.|-|_)[\w]+)*@([\w]+)((\.|-)[\w]+)*(\.[a-zA-Z]{2,6})))*)$/;

	function error(message)
	{
		alert(message);
		return false;
	}

	$('#addglobalsummaryreportform').hide();

	$('#addnewglobalsummaryreport').click(function(){
		if (!global_summary_report_creation_finished() || !global_summary_report_viewing_finished())
			return false;

		$(this).parent().slideUp(50);

		$('#addglobalsummaryreportform').ajaxForm({
			target: '#list',
			beforeSubmit: function(formData, jqForm, options){
				// this doesn't work!!!
				// $('#reportname').val(jQuery.trim($('#reportname').val()));
				// so this ugly workaround is used
				for (var i=0; i < formData.length; i++) {
					if (formData[i].name == 'reportname')
						formData[i].value = jQuery.trim(formData[i].value);
					if (formData[i].name == 'description')
						formData[i].value = jQuery.trim(formData[i].value);
				}
				// the following still works as usual
				if ($('#reportname').val() == "")
					return error('Please enter the report name');

				if (!rxReportName.test($('#reportname').val()))
					return error('Report name is invalid.');
			},
			success: function(){
				$('#addglobalsummaryreportform').slideUp(500, function(){
					$('#addglobalsummaryreportform table').remove();
					$('#addnewglobalsummaryreport').parent().slideDown(50);
				});
			}
		});

		$('#addglobalsummaryreportform').load('/logserver/view/reports/globalsummaryreportform.inc.php', function(){
			$(this).slideDown(500);
			$('#reportname').focus();
			$('#action').val('create');
			$('#type').val('global');

			$('#filter').load('/logserver/comps/summary?type=addglobal');

			$('#cancel').click(function(){
				$('#addglobalsummaryreportform').slideUp(500, function(){
					$('#addglobalsummaryreportform table').remove();
					$('#addnewglobalsummaryreport').parent().slideDown(50);
				});
				return false;
			});
		});
	});

	$('#list').load('/logserver/comps/summary?type=global');

	$('#list > .end').livequery(function(){
		$('#list table').tablesorter({sortList: [[0, 0]],
			headers: {1: {sorter: false}, 2: {sorter: false}}});

		$('.edit a').click(function(){
			if (global_summary_report_creation_finished() && global_summary_report_viewing_finished())
			{
				var original = $(this).parent().parent();

				original.hide();

				var globalsummaryreportname = $(this).parent().siblings().eq(0).text();

				original.after('<tr id="editrow"><td colspan="9" align="center"><form id="viewglobalsummaryreportform" action="#"><br /><a name=' + globalsummaryreportname.replace(/ /g, '+') + '><img id="graph-images" src="#"></span></a><span id="top-host"></span><br /><input type="button" id="cancel" class="button hide" value="Collapse" /></form></td></tr>');
				$('#viewglobalsummaryreportform').hide();
				$('#graph-images').attr('src','/logserver/comps/summary?type=graph&time=43200&filter=' + globalsummaryreportname.replace(/ /g, '+'));
				$('#graph-images').after('<br /><a id="1-year" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">1 Year</a> <a id="1-month" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">1 Month</a> <a id="2-week" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">2 Weeks</a> <a id="1-week" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">1 Week</a> <a id="1-day" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">1 Day</a> <a id="12-hours" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">12 Hours</a> <a id="1-hour" href="#'
							 + globalsummaryreportname.replace(/ /g, '+') + '">1 Hour</a><br />');
				$('#top-host').load('/logserver/comps/summary?type=host&filter=' + globalsummaryreportname.replace(/ /g, '+'));

				$('#1-year, #1-month, #2-week, #1-week, #1-day, #12-hours, #1-hour').click(function(){
					switch($(this).attr('id'))
					{
						case "1-year":
							time=31536000;
							break;

						case "1-month":
							time=2592000;
							break;

						case "2-week":
							time=1209600;
							break;

						case "1-week":
							time=604800;
							break;

						case "1-day":
							time=86400;
							break;

						case "12-hours":
							time=43200;
							break;

						case "1-hour":
							time=3600;
							break;
					}

				$('#graph-images').attr('src','/logserver/comps/summary?type=graph&time='+ time +'&filter=' + globalsummaryreportname.replace(/ /g, '+'));
				});

				$('#viewglobalsummaryreportform').slideDown(500);

				$('#cancel').click(function(){
					$('#viewglobalsummaryreportform').slideUp(500, function(){
						$('#editrow').remove();
						original.show();
					});
					return false;
				});
			}

			return false;
		});

		$('#list > table td').dblclick(function(){
			$(this).parent().children('.edit').children('a').click();
			return false;
		});

		$('.remove a').click(function(){
			if (global_summary_report_creation_finished() && global_summary_report_viewing_finished())
			{
				var globalsummaryreportname = $(this).parent().siblings().eq(0).text();

				//$('tr.msg').remove();
				if (confirm("Remove report '" + globalsummaryreportname + "'?"))
					$('#list').load('/logserver/comps/summary?action=delete&type=global&filter=' + globalsummaryreportname.replace(/ /g, '+'), function(){
						alert("Report '" + globalsummaryreportname + "' has been deleted.");
					});
			}

			return false;
		});
	});
}
