<?php

$filters = (isset($_POST['filters']))? $_POST['filters'] : array();
$suffix = (count($filters) == 1)? $filters[0] : 'filters';

Audit::track('export filters');

function print_tab($indent)
{
	$i = 1;
	$html = "";
	while ($i <= $indent) {
		$html.= "\t";
		$i++;
	}
	return $html;
}

function export_children($filtername, $tabs=1)
{
	global $xml;
	global $filters;

	if (!count($filters))
		return;

	$children = Database::query("SELECT name, query FROM filters WHERE"
		. " parent_id = (SELECT id FROM filters WHERE name = '$filtername') ORDER BY name");

	foreach ($children as $child)
	{
		$key = array_search($child['name'], $filters, true);
		if ($key === FALSE)
			continue;
		else
			unset($filters[$key]);

		$xml .= "\n".print_tab($tabs).'<filter name="' . htmlspecialchars($child['name'])
			. '" query="' . htmlspecialchars($child['query']) . '">';

		$child_count = export_children($child['name'], $tabs+1);

		if ($child_count > 0) {
			$xml .= "\n".print_tab($tabs).'</filter>';
		} else {
			$xml .= '</filter>';
		}
	}
	return count($children);
}

header("Cache-Control: public, must-revalidate");

if (isset($_SERVER['HTTP_USER_AGENT']) &&
	strpos($_SERVER['HTTP_USER_AGENT'],'MSIE 7'))
{
	header("Pragma: hack");
	header("Content-Type: application/octet-stream");
	header("Content-Transfer-Encoding: binary\n");
}
else
	header('Content-Type: text/xml');

header('Content-Description: File Transfer');
header('Content-Disposition: attachment; filename='
	. gethostbyaddr('127.0.0.1') . '_' . $suffix . '.xml');

$tabs = 1;
$xml = '<?xml version="1.0" standalone="yes"?>'."\n"
	. '<op5-logserver>'."\n".'<filters>'."\n".print_tab($tabs).'<filter name="All" query="">';


$count = export_children('All', $tabs+1);

$xml .= "\n".print_tab($tabs)."</filter>\n</filters>\n</op5-logserver>";

header("Content-Length: " . strlen($xml));

echo $xml;
