<?php

if (!isset($_FILES['xml_file']))
	exit;

Audit::track('import filters', "File: '{$_FILES['xml_file']}'");

require ('comps/filters/model.php');

$model = new FiltersModel;
$failed = array();

function import_children($node, $parentname)
{
	global $model;
	global $failed;

	foreach ($node->children() as $filter)
	{
		if (!$model->exists($filter['name']))
		{
			if ($model->add_global_filter($filter['name'], $filter['query'], $parentname))
				import_children($filter, $filter['name']);
			else
				$failed[] = $filter['name'];
		}
		elseif ($model->is_global($filter['name'])
			&& $model->get_query($filter['name']) == $filter['query'])
		{
			import_children($filter, $filter['name']);
		}
		else
			$failed[] = $filter['name'];
	}
}

if (($data = @file_get_contents($_FILES['xml_file']['tmp_name'])) === FALSE)
{
	echo '<span class="error">Could not load the file.</span>';
	exit;
}

try
{
	$xml = new SimpleXMLElement($data);

	import_children($xml->filters->filter[0], 'All');

	if (count($failed))
		echo '<span class="error">The following filters and their children were not imported: "'
			. implode('", "', $failed) . '"</span>';
	else
		echo '<span class="ok">Filters have been imported.</span>';
}
catch (Exception $e)
{
	echo '<span class="error">Bad file format.</span>';
}
