#!/usr/bin/php
<?php

/*		
 * Author: Arsenij Chystyakov <achystyakov@n-ix.com.ua> 
 *		
 * Send reports to mails or put it on some local dir
 * 
 * */

set_include_path('.:/opt/logserver/gui/');
require ('libs/config.php');
require ('libs/database.php');
require ('comps/filters/model.php');

class parser_filter_pages
{
	private $PATH = "/opt/logserver/reports/temp";
	private $archiv_path = "/"; // NEED FIELD

	private $db_name = Config::dbname;
	private $db_pass = Config::dbpassword;
	private $db_user = Config::dbuser;
	private $db_host = Config::dbhost;
	private $db_port = "5432";

	private $header = "/opt/logserver/reports/template-head.html";
	private $footer = "/opt/logserver/reports/template-foot.html";

	private function mail_attachment ($from , $to, $subject, $message, $attachment)
	{
		$fileatt = $attachment; // Path to the file
		$fileatt_type = "application/octet-stream"; // File Type
		$start = strrpos($attachment, '/') == -1 ? strrpos($attachment, '//') : strrpos($attachment, '/')+1;
		$fileatt_name = substr($attachment, $start, strlen($attachment)); // Filename that will be used for the file as the attachment

		$email_from = $from; // Who the email is from
		$email_subject =  $subject; // The Subject of the email
		$email_txt = $message; // Message that the email has in it

		$email_to = $to; // Who the email is to

		$headers = "From: ".$email_from;

		$file = fopen($fileatt,'rb');
		$data = fread($file,filesize($fileatt));
		fclose($file);
		$msg_txt="\n\n";

		$semi_rand = md5(time());
		$mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";

		$headers .= "\nMIME-Version: 1.0\n"
			. "Content-Type: multipart/mixed;\n"
			. " boundary=\"{$mime_boundary}\"";

		$email_txt .= $msg_txt;

		$email_message = "This is a multi-part message in MIME format.\n\n"
			. "--{$mime_boundary}\n"
			. "Content-Type:text/html; charset=\"iso-8859-1\"\n"
			. "Content-Transfer-Encoding: 7bit\n\n".$email_txt."\n\n";

		$data = chunk_split(base64_encode($data));

		$email_message .= "--{$mime_boundary}\n"
			. "Content-Type: {$fileatt_type};\n"
			. " name=\"{$fileatt_name}\"\n"
			//. "Content-Disposition: attachment;\n"
			//. " filename=\"{$fileatt_name}\"\n"
			. "Content-Transfer-Encoding: base64\n\n"
			. $data . "\n\n"
			. "--{$mime_boundary}--\n";


		$ok = @mail($email_to, $email_subject, $email_message, $headers);

		if(!$ok)
			die("");
	}

	public function parse($param, $name="")
	{
		$dbconn = pg_connect("dbname=$this->db_name user=$this->db_user");

		$head_res = fopen($this->header, "r");
		$head = fread($head_res, filesize($this->header));
		fclose($head_res);

		$foot_res = fopen($this->footer, "r");
		$foot = fread($foot_res, filesize($this->footer));
		fclose($foot_res);

		if ($param == "immediately")
		{
			$sql = "SELECT id, name, recipients, filter, interval_type, recipient_type, userid FROM reports WHERE name = '$name'";
			$result = pg_query($sql);
		}
		else
		{
			$sql = "SELECT id, name, recipients, filter, interval_type, recipient_type, userid FROM reports WHERE interval_type = '$param'";
			$result = pg_query($sql);
		}

		while(list($id, $name, $recipients, $filter, $interval, $type, $user) = pg_fetch_row($result))
		{
			if ($param != "immediately")
			{
				switch ($interval)
				{
					case 0:
						$start = date ("Y-m-d+00:00:00", time()-24*60*60-40*60+30);
						$end = date ("Y-m-d+23:59:59", time()-24*60*60-40*60+30);
						$marker = "daily";
						break;

					case 1:
						$start = date("Y-m-d+00:00:00", time()-7*24*60*60); //Update for cron at 01 hours every week
						$end = date ("Y-m-d+23:59:59", time()+24*60*60);
						$marker = "weekly";
						break;

					case 2:
						$days_num = intval(date("t", time()-60*60*2-24*60*60*28+30));
						$start = date("Y-m-01+00:00:00", time()-60*60*2-24*60*60*28+30); // Update for cron at 02 hours every month
						$end = date("Y-m-$days_num+23:59:59", time()-60*60*2-24*60*60*28+30);
						$marker = "monthly";
						break;

					//************************************//

					case 3:
						$start = date("Y-m-d+H:00:00", time()-60*60+60*10); // In the 10 minute of every hour
						$end = date("Y-m-d+H:59:59", time()-60*60+60*10);
						$marker = "hourly";
						break;

					case 4:
						$start = date("Y-m-d+H:00:00", time()-60*60*6+60*20); // In the 20 minute of every 6 hour
						$end = date("Y-m-d+H:59:59", time()-60*60+60*20);
						$marker = "6hourly";
						break;

					case 5:
						$start = date("Y-m-d+H:00:00", time()-60*60*12+60*30); // In the 30 minute of every hour
						$end = date("Y-m-d+H:59:59", time()-60*60+60*30);
						$marker = "12hourly";
						break;
				}
			}
			else
			{
				switch ($interval)
				{
					case 0:
						$start = date ("Y-m-d+00:00:00", time());
						$end = date ("Y-m-d+23:59:59", time());
						$marker = "daily";
						break;

					case 1:
						$week_day = intval(date("w", time()));
						$start = date("Y-m-d+00:00:00", time()-7*24*60*60); //Update for cron at 01 hours every week
						$end = date ("Y-m-d+23:59:59", time()+24*60*60);
						$marker = "weekly";
						break;

					case 2:
						$days_num = intval(date("t", time()-60*60*2-24*60*60*28+30));

						echo "$days_num\n\n";
						$start = date("Y-m-01+00:00:00", time()-60*60*2-24*60*60*28+30);
						$end = date("Y-m-$days_num+23:59:59", time()-60*60*2-24*60*60*28+30);
						$marker = "monthly";
						break;

					//************************************//

					case 3:
						$start = date("Y-m-d+H:00:00", time()-60*60); // In the 10 minute of every hour
						$end = date("Y-m-d+H:59:59", time()-60*60);
						$marker = "hourly";
						break;

					case 4:
						$start = date("Y-m-d+H:00:00", time()-60*60*6); // In the 20 minute of every 6 hour
						$end = date("Y-m-d+H:59:59", time()-60*60);
						$marker = "6hourly";
						break;

					case 5:
						$start = date("Y-m-d+H:00:00", time()-60*60*12); // In the 30 minute of every hour
						$end = date("Y-m-d+H:59:59", time()-60*60);
						$marker = "12hourly";
						break;
				}
			}

			$flag = 1;

			@$server = $_SERVER['HOSTNAME'];
			$urlfilter = str_replace(" ", "+", $filter);

			if ($user != 0)
			{
				if ($this->is_accessible($filter, $user))
				{
					$url = "https://127.0.0.1/logserver/comps/inquire?filter=".$urlfilter."&start_time=".$start."&end_time=".$end."&limit=5000&offset=0";
					print $url;

					$filename = "$name-$marker-".substr($start, 0, 10)."-".substr($start, 11, 5).".html";
					$filename = str_replace(":", "-", $filename);

					$start = str_replace("+", " ", $start);
					$end = str_replace("+", " ", $end);
					$from = "op5logserver$server";
					$msg = "op5 Logserver $marker report <br><br>\r\n\r\nReport timespan: $start to $end<br><br>\r\n\r\nNote: the report is currently limited to 5000 log messages (rows)<br><br>";

					$doc = file_get_contents($url);
					$in = explode("</form>", $doc);
					$out = "$head\n $msg"."$in[1] \n$foot";
				}
				else
				{
					$filename = "$name-$marker-".substr($start, 0, 10)."-".substr($start, 11, 5).".html";
					$filename = str_replace(":", "-", $filename);
					$out = "Filter doesn't exist or reports administrators don't have permission for this filter.";
					$flag = 0;
				}
			}
			else
			{
				$url = "https://127.0.0.1/logserver/comps/inquire?filter=".$urlfilter."&start_time=".$start."&end_time=".$end."&limit=5000&offset=0";

				$filename = "$name-$marker-".substr($start, 0, 10)."-".substr($start, 11, 5).".html";
				$filename = str_replace(":", "-", $filename);

				$start = str_replace("+", " ", $start);
				$end = str_replace("+", " ", $end);
				$from = "op5logserver$server";
				$msg = "op5 Logserver $marker report <br><br>\r\n\r\nReport timespan: $start to $end<br><br>\r\n\r\nNote: the report is currently limited to 5000 log messages (rows)<br><br>";

				$doc = file_get_contents($url);
				$in = explode("</form>", $doc);
				$out = "$head\n$msg"."$in[1] \n$foot";
			}


			if ($type == 1)
			{
				if (substr($recipients, 0, 1) == "/")
					$recipients = substr($recipients, 1);
				if (substr($recipients, -1) == "/")
					$recipients = substr($recipients, 0, -1);

				$dir = explode("/", $recipients);

				$create_dir = array();
				$str = "$this->archiv_path";

				chdir("$this->archiv_path");

				for($i=0; $i<count($dir); $i++)
				{
					if (is_dir($dir[$i]))
					{
						$str .= $dir[$i]."/";
						chdir("$str");
					}
					else
						$create_dir[] = $dir[$i];
				}

				foreach($create_dir as $dir_name)
				{
					mkdir("$str/$dir_name");
					chmod("$str/$dir_name", 0777);
					$str .= $dir_name."/";
				}

				if (file_exists("$str$filename"))
					unlink("$str$filename");

				$file_handler = fopen("$str$filename", "a");

				flock($file_handler, LOCK_EX);
				if (fwrite($file_handler, $out) === FALSE)
					continue;

				flock($file_handler, LOCK_UN);
				fclose($file_handler);

				if ($param == "immediately")
				{
					$path = "$str$filename";
					echo "<span class=\"report-path-hiden\">$path</span>";
				}
			}
			else
			{
				if (!is_dir($this->PATH))
				{
					mkdir("$this->PATH");
					chmod("$this->PATH", 0777);
				}

				$file_handler = fopen("$this->PATH/$filename", "a") or die("");

				flock($file_handler, LOCK_EX);
				if (fwrite($file_handler, $out) === FALSE)
					continue;

				flock($file_handler, LOCK_UN);
				fclose($file_handler);

				@$server = "@".$_SERVER['HOSTNAME'];

				$start = str_replace("+", " ", $start);
				$end = str_replace("+", " ", $end);
				$from = "op5logserver$server";
				$msg = "op5 Logserver $marker report <br><br>\r\n\r\nReport timespan: $start to $end<br><br>\r\n\r\nNote: the report is currently limited to 5000 log messages (rows)";
				$subject = "op5logserver $marker report: $filter";
				$attach = "$this->PATH/$filename";
				chmod($attach, 0777);
				if ($flag)
					$this->mail_attachment($from, $recipients, $subject, $msg, $attach);
				else
					mail($recipients, $subject, $out);

				unlink("$this->PATH/$filename");
			}
		}
	}

	private function is_accessible($filtername, $name)
	{
		$model = new FiltersModel();

		list($username) = pg_fetch_row(pg_query("SELECT name FROM users WHERE id='$name'"));

		$global_filters = $model->get_global_filters($username);
		$own_filters = $model->get_own_filters($username);
		$filters = array_merge($global_filters, $own_filters);
		if (in_array($filtername, $filters))
			return true;
		else
			return false;
	}
}

$obj = new parser_filter_pages();
if (isset($argv[2]))
	@$obj->parse($argv[1], $argv[2]);
else
	@$obj->parse($argv[1]);
