#!/bin/bash
#
# op5 LogServer draw graph from RRD DB
# Author: Chystyakov Arsenij <achystyakov@n-ix.com.ua>
#

RRDPATH="/opt/logserver/rrd/"
now=`date +%s`
starttime=$(echo "$now-$3" | bc)
startstr=$(date -d "1970-01-01 $starttime sec" +"%Y-%m-%d %H\:%M\:%S")
endstr=$(date -d "1970-01-01 $now sec" +"%Y-%m-%d %H\:%M\:%S")

/usr/bin/rrdtool graph - \
--imgformat=PNG \
--start=$starttime \
--end=$now \
--title="Logs per minute - Filter $2" \
--base=1000 \
--alt-autoscale-max \
--lower-limit=0 \
COMMENT:"From $startstr To $endstr\c" \
COMMENT:"  \n" \
--vertical-label="Logs" \
--slope-mode \
--watermark="http://www.op5.com" \
DEF:a="$RRDPATH/$1.rrd":logs:AVERAGE \
DEF:b="$RRDPATH/$1.rrd":logs:LAST \
DEF:c="$RRDPATH/$1.rrd":logs:MIN \
DEF:d="$RRDPATH/$1.rrd":logs:MAX \
AREA:a\#1599d032:""  \
LINE1:a\#1599d0FF:"Filter\: $2"  \
GPRINT:b:LAST:"Last\:%5.1lf %s"  \
GPRINT:a:AVERAGE:"Avg\:%5.1lf %s"  \
GPRINT:d:MAX:"Max\:%5.1lf %s"
