<?php

set_include_path('/opt/logserver/gui/');

require_once ('libs/config.php');
require_once ('libs/database.php');
require_once ('libs/auth.php');
require_once ('libs/audit.php');

require_once("comps/settings/model.php");
$m = new SettingsModel();

Auth::init($m->is_use_ldap() ? "ldap" : NULL);

$goto = (isset($_GET['goto']) && ($_GET['goto']) != '')? $_GET['goto'] : 'view/logs';

// remove trailing slash
if (substr($goto, -1) == '/')
	$goto = substr($goto, 0, -1);

// redirect view to view/logs
if ($goto == 'view')
	$goto = 'view/logs';

// show auth page for unauthorized users
if (Auth::$username === false && $goto != 'css/auth.css' && $goto != 'js/jquery.js'
	&& $_SERVER['REMOTE_ADDR'] != '127.0.0.1')
{
	$goto = 'comps/auth';
}

if (preg_match('#^comps/([a-z]+)$#', $goto, $matches)
	&& is_dir("/opt/logserver/gui/{$matches[0]}"))
{
	
	require_once ("{$matches[0]}/model.php");
	require_once ("{$matches[0]}/controller.php");
	
	if (file_exists("/opt/logserver/gui/{$matches[0]}/view.php")) {
		include ("{$matches[0]}/view.php");
	}
	
}
else if (preg_match('#^view/([a-z]+)$#', $goto, $matches)
	&& is_dir("/opt/logserver/gui/{$matches[0]}"))
{
	$view = $matches[1];
	include ('view/index.php');
}
else if (preg_match('#^(css|js|view/[a-z]+)/([-_a-z0-9\.]+)\.(css|js|inc\.php|pdf)$#', $goto, $matches)
	&& is_file("/opt/logserver/gui/{$matches[0]}"))
{
	if ($matches[3] == 'inc.php')
		include ($matches[0]);
	else
	{
		$file = fopen("/opt/logserver/gui/{$matches[0]}", 'rb');
		if ($matches[3] == 'pdf')
		{
			if (isset($_SERVER['HTTP_USER_AGENT'])
				&& strpos($_SERVER['HTTP_USER_AGENT'],'MSIE 7'))
			{
				header("Pragma: hack");
				header("Content-Type: application/octet-stream");
				header("Content-Transfer-Encoding: binary");
				header('Content-Description: File Transfer');
				header('Content-Disposition: attachment; filename=' . $matches[2] . '.' . $matches[3]);
			}
			else
				header('Content-Type: application/pdf');
		}
		else
			header('Content-Type: text/' . (($matches[3] == 'css')? 'css' : 'javascript')
				. '; charset=utf-8');
		header("Content-Length: " . filesize("/opt/logserver/gui/{$matches[0]}"));
		fpassthru($file);
		exit;
	}
}
else
{
	$view = 'logs';
	include ('view/index.php');
}
